/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

var message_pnotify = null;

function print_message(body, type){
    if ( typeof arguments[0] == 'object' ) {
        if ( body.message ) {
            if ( body.message.type ) {
                type = body.message.type;
            }

            var message = body.message.body;
            if ( body.error ) {
                type = 'error';

                if ( body.object ) {
                    message = 'Wystpiy bdy: <ol>';
                    for( var err in body.object ){
                        message += '<li>' + body.object[ err ] + '</li>';
                    }
                    message += '</ol>';
                }
            }
            body = message;
        } else {
            type = body.type;
            body = body.body;
        }
    }

    var delay = Math.max( 5000, (body.length / 5) * 800);  //czas wyswietlania w zaleznosci od dlugosic tekstu
    var title = (type == 'error')? 'Bd' : 'Informacja';
    if( !type ) type = 'notice';

    if ( message_pnotify && message_pnotify.pnotify_remove){
        message_pnotify.opts.pnotify_animation = 'none';
        message_pnotify.pnotify_remove();
    }

    message_pnotify = jQuery.pnotify({
        pnotify_title: title,
        pnotify_type: type,
        pnotify_text: body,
        pnotify_hide: true,
        pnotify_delay: delay,
        pnotify_animation: 'fade',
        styling: "jqueryui",
    });
}

var $confirmDialog = null;
function confirmDialog( message, options ){
    var confirmCallback = null;

    if ( !$confirmDialog || ($confirmDialog.length == 0) ) {
        $confirmDialog = $('#confirmDialog');

        if ( $confirmDialog.length == 0 ) {
            $('body').append(
                $confirmDialog = $('<div id="confirmDialog"></div>').hide()
            );
        }

        $confirmDialog.dialog( {
            'autoOpen' : false,
            'model' : false,
            'maxWidth': 800,
            'maxHeight': 600,
            'position' : 'center',
            'title' : 'Komunikat',
            'width' : 400,
            'height' : 'auto',
            'close' : function (){
                hideTlo();
            },
            'open' : function (){
                showTlo();
            }
        });
    }

    $confirmDialog.html(message);

    if ( !options ) options = {};

    if ( typeof(options) == 'function' ){
        confirmCallback = options;
        options = {};
    }

    if ( options.confirm  ) {
        if( typeof(options.confirm) == 'function'){
            confirmCallback = options.confirm;
        }

        delete options['confirm'];
    }

    $confirmDialog.dialog( 'option', 'buttons',  [
        {
            text: "Anuluj",
            icons : {
                'primary' : 'ui-icon-cancel'
            },
            click: function() {$(this).dialog("close");}
        },
        {
            text: "Ok",
            icons : {
                'primary' : 'ui-icon-check'
            },
            click: function() {
                $(this).dialog("close");

                if( confirmCallback ){
                    confirmCallback();
                }
            }
        }
    ]);

    var o, optionsList = [ 'title', 'modal' ];
    for( var i = 0; i < optionsList.length; i++ ) {
        o = optionsList[i];
        if ( options[o] ) {
            $confirmDialog.dialog( 'option', o, options[o] );
        }
    }

    $confirmDialog.dialog( "open" );
}

if( jQuery.validator ){
    jQuery.validator.addMethod("deltacityNazwa", function(value, element) {
        return this.optional(element) || /^[a-zA-Z\-_]+$/i.test(value);
    }, "Nazwa konfiguracji moe skada si wycznie z liter i cyfr");
}

jQuery.fn.textPlaceholder = function () {
    return this.each(function(){
        var that = this;

        var placeholder = that.getAttribute('title');
        var input = jQuery(that);

        if (that.value === '' || that.value == placeholder) {
            input.addClass('text-placeholder');
            that.value = placeholder;
        }

        input.focus(function(){
            if (input.hasClass('text-placeholder')) {
                this.value = '';
                input.removeClass('text-placeholder')
            }
        });

        input.blur(function(){
            if (this.value === '') {
                input.addClass('text-placeholder');
                this.value = placeholder;
            } else {
                input.removeClass('text-placeholder');
            }
        });
    });
};

var DeltaCity = {
    'config' : '', //nazwa aktywnej konfiguracji
    'settings' : null,
    'template' : null,
    'templates' : null,
    'paczki' : [], //aktualne paczki, pocztkowa pusta lista
    'paczkaIndex': -1, //aktualnie zmieniana paczka
    'paczkiTypy': {},
    'doc_type' : 'zk',
    'options' : [], //opcje do selecta
    'docs' : [] //opcje do selecta
};


(function(){
    var $settingsDialog, $deltacityPaczki, $zkStatusDialog, $dokumentDialog, $przesylkaDialog, $paczkaDialog, $kontrahentDialog, $eksportDialog, $settingsValidator, $dialog, $activeDialog, docSelection;


    var dialogOptions = {
          title: '',
          bgiframe: true,
          show: 'clip',
          hide: 'clip',
          width: 'auto',
          height: 'auto',
          minWidth: 300,
          minHeight: 100,
          maxWidth: 800,
          closeOnEscape: true,
          autoOpen: false,
          modal: false,
          draggable: true,
          'open': function(event, ui) {
              showTlo();
          },
          'close': function(){
              hideTlo();
          }
    };

    var metadataOptions = {
        type: 'attr',
        name: 'data'
    }

/**************************************************************************************************/
    function __html_replace( html, data, prefix ){
        if ( !prefix ) prefix = '%';

        if ( html && typeof(data) == 'object') {
            for ( var key in data ){
                 if ( typeof(data[key]) == 'object' ){
                    html = __html_replace( html, data[key], prefix + key + '\\.' );
                }else if ( typeof(data[key]) == 'string' || typeof(data[key]) == 'number' ){
                    html = html.replace(new RegExp( prefix + key + '%','g'), data[key]);
                }
            }
        }

        return html;
    }

    function print_object( template, data ){
        var html = jQuery(template).clone(false).removeClass('template').show().wrap('<div></div>');

        html = __html_replace( html.parent().html(), data );
        html = html.replace(new RegExp( '%[a-zA-Z0-9_\\.\\-]+%','g'), '&nbsp;');

        return html;
    }

    function save_object( data, options ){//wstawia obiekt zwrcony z serwera do HTML
        var html = print_object('#'+ options.model_parent + ' ' + ( options.tpl ? options.tpl : '.tpl') , data);

        if ( empty(html) ) {
            console.log('Nie znaleziono obiektu: ' + '#' + options.model_parent + ' .tpl');
            return false;
        }

        var insert = jQuery(html);
        if( options.attach_handlers && typeof(options.attach_handlers) == 'function' ){
            try{
                options.attach_handlers(insert);
            }catch(err){
                if ( console && console.log && typeof(console.log) == 'function' ){
                    console.log(err);
                }
            }
        }

        if ( options.mode && (options.mode == 'edit' || options.mode == 'update') ) {
            jQuery( '#' + options.model + data.id ).replaceWith(insert);
        } else {
            insert.css("display", "none");
            jQuery( '#'+ options.model_parent ).append(insert);
            insert.fadeIn("slow");
        }
    }

/**************************************************************************************************/

    var settingsAjax = {
        error: function(jqXHR, textStatus, errorThrown){
            //console.log(textStatus);
            //console.log(jqXHR);
            //console.log(errorThrown);

            hideLoading();
            print_message( 'Przez serwer zostaa zwrcona nieprawidowa odpowied' );

            if ( $activeDialog ) {
                $activeDialog.dialog("enable");
                $activeDialog.dialog("close");
                $activeDialog = null;
            }
        },

        beforeSubmit:  function(){
            if( $activeDialog ){
                $activeDialog.dialog("disable");
            }
            showLoading(0, 0, 1100);
        }
    }

    function settingsOptions() {
        var $select = $('#deltacitySettingsDialog').find('select[name=config]');
        var option = null, update = false;

        if( !DeltaCity.options ){
            DeltaCity.options = [];
        }

        if ( DeltaCity.settings && (!DeltaCity.options || DeltaCity.options.length == 0) ) {
            DeltaCity.options = [];
            for( var o in DeltaCity.settings ){
                if( typeof(DeltaCity.settings[o]) == 'object' ){
                    DeltaCity.options.push(o) ;
                }
            }

            update = true;
        }

        if ( !$select.val() ) {
            option = $('#deltacitySettingsDialog').find('input[name=nazwa]').val();
        }

        if ( option ) {
            DeltaCity.options.push(option);

            update = true;
        }

        if ( update ) {
            $select.children('option:gt(0)').remove();

            DeltaCity.options.sort();
            for ( var i = 0; i < DeltaCity.options.length ; i++ ) {
                $select.append('<option value="' + DeltaCity.options[i]+ '">' + DeltaCity.options[i] + '</option>');
            }
        }
    }

    function settingsOpen( e ){
        e.preventDefault();

        if ( !$settingsDialog ) {
            dialogOptions.title = 'Konfiguracja WebApi DeltaCity';
            dialogOptions.buttons = [
                {
                    text: "Anuluj",
                    icons : {
                        'primary' : 'ui-icon-cancel'
                    },
                    click: function() {$(this).dialog("close");}
                },
                {
                    text: "Usu",
                    icons : {
                        primary : 'ui-icon-trash'
                    },
                    click: settingsDelete
                },
                {
                    text: "Zapisz",
                    icons : {
                        primary : 'ui-icon-disk'
                    },
                    click: function() {
                        $(this).find("form").submit();
                    }
                }
            ];

            $settingsDialog = $('#deltacitySettingsDialog').dialog( dialogOptions );

            $settingsDialog.find('input[type=submit]').hide();

            $settingsDialog.find('.set-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-circle-check'
                },
                'text' : false
            }).click(settingsSet);

            $settingsDialog.find('select[name=config]').change(settingsSelect);

            settingsOptions();

            $settingsValidator = $settingsDialog.find('form').validate({
                submitHandler: settingsSave
            });
        }

        $settingsDialog.dialog('open');

        return false;
    }

    function settingsSave( form ) {
        $activeDialog = $settingsDialog;

        jQuery(form).ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsOptions();
                    settingsUpdate();

                    $('.clearable', form).clearFields();

                    $settingsDialog.dialog("close");
                    $activeDialog = null;
                } else {
                    $settingsValidator.showErrors(data.object);
                }
            }
        }));
    }

    function settingsSet( e ){
        e.preventDefault();

        var config = $('#deltacitySettingsDialog input[name=nazwa]').val();

        if ( !config || config == '' ) {
            print_message( 'Wybierz konfiguracj ktr chcesz uzywa do polczenia si z serwisem WebApi DeltaCity' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': this.href,
            'dataType':  'json',
            'data':  {'config' : config},

            'success': function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsUpdate()
                }
            }
        }));

        //console.log(settingsAjax);

        return false;
    }

    function settingsDelete( e ){
        e.preventDefault();

        var config = $('#deltacitySettingsDialog input[name=nazwa]').val();

        if ( !config ) {
            print_message( 'Wybierz konfiguracj ktr chcesz usun' );
            return false;
        }
        var mode = $('#deltacitySettingsDialog input[name=mode]').val();

        $.ajax($.extend({}, settingsAjax, {
            'url': DeltaCity.url,
            'dataType':  'json',
            'data':  {'mode' : mode, 'delete' : config},

            'success': function(data) {
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    if ( config && DeltaCity.settings[config] ){
                        delete DeltaCity.settings[config];
                        $('#deltacitySettingsDialog form').clearForm();
                        DeltaCity.options = [];
                        settingsOptions();
                    }
                }
            }
        }));

        return false;
    }

    function formSetValues( form, data, opcje ) {
        var $form = $(form), el = '';

        if ( typeof(opcje) == 'undefined' ){
            opcje = {};
        }

        if ( typeof(opcje) != 'object' ){
            opcje = {'clear' : opcje};
        }

        opcje  = $.extend({
            'clear' : false,
            'prefix' : '',
            'sufix' : ''
        }, opcje);

        if ( opcje.clear ) {
            if ( typeof(opcje.clear) == 'object' ) {
                opcje.clear.clearFields();
                //console.log( data );
//                for( var i = 0; i < opcje.clear.length; i++ ){
//                    console.log( (i+1) + '. ' + opcje.clear[i].name );
//                }
            } else if ( typeof(opcje.clear) == 'string' ) {
                $form.find(opcje.clear).clearFields();
            }else{
                $form.clearForm();
            }

            $form.find('input[title]').each(function(){
                if( (!this.value || this.value == '') && this.title ){
                    this.value = this.title;
                }
            });
        }

        if ( typeof(data) == 'object' ){
            for ( var f in data ) {
                el = opcje.prefix + f + opcje.sufix;
                //console.log('el: ' + el + ' = ' + data[f] );
                if ( typeof(data[f]) == 'object' ) {
                    formSetValues(form, data[f], {
                        'prefix' : el + '[',
                        'sufix' : ']'
                    });
                } else if ( form.elements[el] ) {
                    if ( form.elements[el].type == 'checkbox' ) {
                        form.elements[el].checked = (data[f] > 0);
                    } else {
                        $(form.elements[el]).val(data[f]);
                    }
                }
            }
        }

    }

    function object_deflatte ( fData ) {
        var object = new Object(), deflatte = {}, pos, k, p;

        for ( var f in fData ) {
            pos = f.indexOf('[');

            if ( pos > -1 ) {
                k = f.substring(0, pos);
                p = f.substring(pos + 1, f.indexOf(']') );
                if ( typeof(object[k]) == 'undefined' ) {
                    object[k] = {};
                }

                object[k][p] = fData[f];

                if ( p.indexOf('[') > -1 && typeof(deflatte[k]) == 'undefined' ){
                    deflatte[k];
                }
            } else {
                object[f] = fData[f];
            }
        }

        for ( k in deflatte ) {
            object[k] = object_deflatte( object[k] );
        }

        return object;
    }

    function formGetValues( form ) {
        var $form = $(form), data = new Object();

        var some_data = $form.find("input, select, textarea").map(function(){
            return {'name': $(this).attr('name'), 'value': ( this.type && this.type == 'checkbox' ) ? (this.checked ? '0' : this.value) : $(this).val()};
        }).get();

        for ( var i = 0; i < some_data.length; i++  ) {
            if ( some_data[i].name ) {
                data[some_data[i].name] = some_data[i].value;
            }
        }

        data = object_deflatte( data );

        //console.log(data);
        return data;
    }

    function settingsSelect(){
        var clear = true;

        if ( this.value ) {
            if ( DeltaCity && DeltaCity.settings && DeltaCity.settings[this.value] ) {
                formSetValues(this.form, DeltaCity.settings[this.value], {'clear' : false});
                clear = false;
            }
        }

        if ( clear ) {
            $(this.form).clearForm();
        }
    }

    function settingsUpdate(){
        var settingsList = $('#deltacitySettingsDialog input').each(function(){
            var value = null;
            if( this.type == 'checkbox' ){
                value = (this.checked ? this.value : false);
            } else {
                value = this.value;
            }

            return {'name' : this.name, 'value' : value};
        });

        var i, settings = {};
        for ( i = 0 ;  i < settingsList.length; i++ ){
            settings[settingsList[i].name] = settingsList[i].value;
        }

        DeltaCity.config = settings.nazwa;
        $('#deltacityApiNazwa').html(settings.nazwa);

        $('#deltacityApiError').fadeOut('slow', function(){
            $(this).remove();
        });
    }

/**************************************************************************************************/
    function sprawdzWybraneDokumenty(){
        if ( docSelection.selected.length == 0 ){
            print_message('Naley wybra zamwienia');
            return false;
        }

        return true;
    }

    function dokumentSave() {
        if ( !sprawdzWybraneDokumenty() ) {
            return false;
        }

        var $form  = $(this);
        docSelection.appendTo(this, {'assoc' : true, 'field' : 'numer_przesylki'});

        //this.submit(); return true;
        var $status = $form.find('select[name=zk_status]');
        var status_id = $status.val(), status = null;
        if ( status_id ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        }

        showLoading();
        $dokumentDialog.dialog('disable');
        $activeDialog = $dokumentDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $dokumentDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    //jeszcze zostanie aktualizacja numeru dokumentu wydania przy zamwieniach
                    if ( data.object ) {
                        var doc_id, $doc_row, doc, i;

                        for ( i = 0; i < data.object.zamowienia.length; i++ ) {
                            doc_id = data.object.zamowienia[i];
                            $doc_row = $('#doc' + doc_id + '_row');

                            if ( $doc_row.length ) {
                                doc = $doc_row.metadata(metadataOptions);
                                if( doc ) {
                                    doc.dokument = data.object.dokument;
                                    $doc_row.attr('data', JSON.stringify(doc));
                                }
                            }

                            if ( status ) {
                                $doc_row.find('.zk-status').html( status );
                            }
                        }
                    }

                    $dokumentDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }


    function dokumentOpen( e ){
        e.preventDefault();

        if ( !$dokumentDialog ) {
            $dokumentDialog = $('#deltacityDokumentWydaniaDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Tworzenie nowego dokumentu wydania',
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zapisz",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $dokumentDialog.find('input[type=submit]').hide();
            $dokumentDialog.find('form').submit(dokumentSave);
        }

        $dokumentDialog.find('.dokumenty').html('<h3>Wybrane dokumenty</h3>');

        if ( docSelection.selected.length > 0 ) {
            var warning, warnings = false, r = null;

            var $ul = $('<ol class="lista"></ol>');
            for ( r in docSelection.records ){
                warning = '';
                if ( !docSelection.records[r].numer_przesylki || docSelection.records[r].numer_przesylki == '' ) {
                    warning = 'Uwaga! Dla tego dokumentu nie zosta jeszcze przygotowany list przewozowy w systemie WebMobile7';
                } else if ( docSelection.records[r].dokument ){
                    warning = 'Uwaga! Dla tego dokumentu zosta ju utworzony dokument wydania o numerze ' + docSelection.records[r].dokument;
                }

                $ul.append( '<li class="rekord" >' + docSelection.records[r].numer + ( warning ? ' <span class="warning" title="'+warning+'" style="float: none; vertical-align:middle">&nbsp;</span>' : '') + '</li>' );

                if ( warning ) warnings = true;
            }

            $dokumentDialog.find('.dokumenty').append($ul);

            $ul.find('.warning').tooltip().button({
                'icons' : {
                    'primary' : 'ui-icon-alert'
                },
                'text' : false
            });

            if ( warnings ) {
                print_message('Uwaga cz wybranych dokumentw nie moe zosta wykorzystana do wygenerowania nowego dokumentu wydania. Sprawd ostrzeenia wywietlane przy numerze dokumentu. Dokumenty przy ktrych s ostrzeenia nie zostan wzite podczas tworzenia dokumentu wydania.');
            }
        } else {
            sprawdzWybraneDokumenty();
        }

        var $zkStatusRow = $('#deltacityDokumentWydaniaZkStatus').parent().parent();
        if ( DeltaCity.doc_type == 'zk' ) {
            $zkStatusRow.show();
        } else {
            $zkStatusRow.hide();
        }
        $dokumentDialog.dialog('open');

        return false;
    }

/**************************************************************************************************/

    function zkStatusSave() {
        if ( !sprawdzWybraneDokumenty() ) {
            return false;
        }

        var $form  = $(this);
        docSelection.appendTo(this);

        //this.submit(); return true;
        var $status = $form.find('select[name=opis_stanu]');
        var status_id = $status.val(), status = null;
        if ( status_id > 0 ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        } else {
            print_message( 'Wybierz status jaki chcesz ustawi dla wybranych zamwie');
            return false;
        }

        showLoading();
        $zkStatusDialog.dialog('disable');
        $activeDialog = $zkStatusDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $zkStatusDialog.dialog( "enable" );

                print_message( data.message );

                //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                if ( data.object ) {
                    var zk_id, $zk_row, i;

                    for ( i = 0; i < data.object.length; i++ ) {
                        if ( data.object[i].error ){
                            continue;
                        }

                        zk_id = data.object[i].id;
                        $zk_row = $('#zamowienie' + zk_id + '_row');

                        if ( $zk_row.length ) {
                            $zk_row.find('.zk-status').html( status );
                        }
                    }
                }

                if ( !data.error ) {
                    $zkStatusDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }


    function zkStatusOpen( e ){
        e.preventDefault();

        if ( !$zkStatusDialog ) {
            $zkStatusDialog = $('#deltacityZamowieniaStatusDialog').dialog( $.extend({},dialogOptions, {
                'title' : this.title,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zmie",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $zkStatusDialog.find('input[type=submit]').hide();
            $zkStatusDialog.find('form').submit(zkStatusSave);
        }

        if ( docSelection.selected.length > 0 ) {
            $zkStatusDialog.find('.zamowienia').html('<h3>Wybrane zamwienia</h3>');
            var r = null, $ul = $('<ol class="lista"></ol>');
            for ( r in docSelection.records ){
                $ul.append( '<li class="rekord" >' + docSelection.records[r].numer + '</li>' );
            }
            $zkStatusDialog.find('.zamowienia').append($ul);
        } else {
            sprawdzWybraneDokumenty();
            return false;
        }

        $zkStatusDialog.dialog('open');

        return false;
    }

/**************************************************************************************************/
    function kontrahentOpen( e ){
        e.preventDefault();

        var $this = $(this);

        if ( !$kontrahentDialog ) {
            $kontrahentDialog = $('#deltacityKontrahentDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Wyszukiwanie kontrahenta',
                'width' : 660,
                'stack' : true,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Wyczy",
                        'icons' : {'primary' : 'ui-icon-trash'},
                        'click': function() {
                            $(this).find("form").clearForm();
                        }
                    },

                    {
                        'text': "Wybierz",
                        'icons' : {primary : 'ui-icon-check'},
                        'click': function() {
                            $(this).dialog("close");

                            var kontrahent = $kontrahentDialog.data('kontrahent');
                            if ( kontrahent ) {
                                var callback = $kontrahentDialog.data('afterSearch');
                                if( typeof(callback) == 'function' ) {
                                    callback( kontrahent );
                                }
                            }
                        }
                    },

                    {
                        'text': "Szukaj",
                        'icons' : {primary : 'ui-icon-search'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $kontrahentDialog.find('input[type=submit]').hide();
            $kontrahentDialog.find('form').submit(kontrahentSubmit);
        }

        $kontrahentDialog.find('input[name=czyNadawca]').val($this.hasClass('czyNadawca') ? '1' : '0');
        if( this.title ){
            $kontrahentDialog.dialog('option', 'title', this.title );
        }
        if ( this.href ) {
            $kontrahentDialog.find('form').attr('action', this.href)
        }

        if ( this.id.indexOf('Nadawca') ) {
            $kontrahentDialog.data('afterSearch', przesylkaUpdateNadawca);
        } else if( this.id.indexOf('Platnik') ){
            $kontrahentDialog.data('afterSearch', przesylkaUpdatePlatnik);
        } else if( this.id.indexOf('Odbiorca') ){
            $kontrahentDialog.data('afterSearch', przesylkaUpdateOdbiorca);
        }

        $kontrahentDialog.dialog('open');

        return false;
    }

    function kontrahentSubmit ( ) {
        var $form  = $(this);

        showLoading();
        $kontrahentDialog.dialog('disable');
        $activeDialog = $kontrahentDialog;

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $kontrahentDialog.dialog( "enable" );

                print_message( data );

                if ( data.error ) {
                    print_message( data );
                } else if ( data.object ) {
                    //jeszcze zostanie aktualizacja numeru kontrahentu przy przesyce
                    $activeDialog = null;
                    $kontrahentDialog.data('kontrahent', data.object);
                    formSetValues($form[0], data.object, 'true');
                } else {
                    print_message( data );
                }
            }
        }));

        return false;
    }
/**************************************************************************************************/
    function paczkaDialogOpen( e ){
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        var $this = $(this);
        if ( !$paczkaDialog ) {
            $paczkaDialog = $('#deltacityPaczkaDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Dodawanie/Edycja podpaczki',
                'width' : 660,
                'stack' : true,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zapisz",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $paczkaDialog.find('input[type=submit]').hide();
            $paczkaDialog.find('form').submit(paczkaSave);
        }

        var paczka = {
            'typ' : '',
            'waga' : '',
            'gab1' : '0',
            'gab2' : '0',
            'gab3' : '0',
            'ksztalt': false
        };

        if ( DeltaCity.przesylkaIndex >= 0 && DeltaCity.paczki && DeltaCity.paczki.length >0 && DeltaCity.przesylkaIndex < DeltaCity.paczki.length ) {
            paczka = DeltaCity.paczki[DeltaCity.przesylkaIndex];
        }

        //ustawiam wartosci w formularzu
        var $input = null;
        if ( paczka ) {
            for ( var a in paczka ) {
                $input = $paczkaDialog.find('input[name=' + a + ']');
                if ( $input.length ) {
                    if ( $input[0].type == 'checkbox' ) {
                        $input[0].checked = paczka[a] ? true : false;
                    } else {
                        $input.val(paczka[a]);
                    }
                }
            }
        }

        $paczkaDialog.dialog('open');
    }

    function paczkaSave( ) {
        var $form  = $(this);

        var paczka = formGetValues($form[0]);
        console.log(paczka);

        if ( !paczka.typ ) {
            alert('Wybierz typ paczki!');
            return false;
        }

        if ( !paczka.waga ) {
            alert('Wpisz wag paczki!');
            return false;
        }

        if ( !DeltaCity.paczki || !DeltaCity.paczki.length || typeof(DeltaCity.paczki.length) == 'undefined' ) {
            DeltaCity.paczki = [];
        }

        if ( DeltaCity.paczkaIndex >= 0 && DeltaCity.paczkaIndex < DeltaCity.paczki.length ) {
            DeltaCity.paczki[DeltaCity.paczkaIndex] = paczka;
        } else {
            DeltaCity.paczki.push(paczka);
        }

        //wypisuje paczki
        deltacityPaczkiPrint();

        //zamykam okno dialogowe paczki
        $paczkaDialog.dialog('close');

        return false;
    }

    function deltacityPaczkaDodaj(){
        DeltaCity.paczkaIndex = -1;

        paczkaDialogOpen();
    }

    function deltacityPaczkaEdytuj ( e ) {
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        var $tr = $(this).parents('tr');
        DeltaCity.paczkaIndex = $tr.index() - 1;
        paczkaDialogOpen();

        return false;
    }

    function deltacityPaczkaUsun ( e ) {
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        if ( confirm('Jeste pewien, e chcesz usun paczk?') ) {
            var $tr = $(this).parents('tr');
            var i = $tr.index() - 1;

            DeltaCity.paczki.splice( i, 1);

            deltacityPaczkiPrint();
        }

        return false;
    }


    function deltacityPaczkiPrint( ) {
        var $paczki_inputs = $('#deltacityPrzesylkaPaczkiInputs');
        if ( !$deltacityPaczki ){
            $deltacityPaczki = $('#deltacityPrzesylkaPaczki');
        }

        var rows = $deltacityPaczki.find('tr');
        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        //czyszce dane dotyczace paczek
        $paczki_inputs.html('');

        if ( DeltaCity.paczki ) {
            var paczka, f;

            for ( var i = 0; i < DeltaCity.paczki.length; i++ ){
                paczka = DeltaCity.paczki[i];
                $deltacityPaczki.append( deltacityPaczkaPrint(paczka, i+1) );

                for( f in paczka ) {
                    $paczki_inputs.append('<input type=hidden name="paczki['+i+']['+f+']" value="'+paczka[f]+'" />');
                }
            }
        }
    }

    function deltacityPaczkaPrint ( paczka, lp ) {
        var $row = $('<tr>');
        if ( lp % 2 == 1 ) {
            //$row.addClass('odd');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(deltacityPaczkaUsun);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(deltacityPaczkaEdytuj);

        var $td = $('<td>');
        $row.append($td.clone().html( lp + '.&nbsp;&nbsp;' ).attr('align', 'right'));

        $row.append($td.clone().html( DeltaCity.paczkiTypy && DeltaCity.paczkiTypy[paczka.typ] ? DeltaCity.paczkiTypy[paczka.typ] : 'Inna' ).attr('align', 'left') );
        $row.append($td.clone().html( paczka.waga + '&nbsp;kg' ).attr('align', 'right') );
        $row.append($td.clone().html( paczka.gab1 + '&nbsp;cm' ).attr('align', 'right') );
        $row.append($td.clone().html( paczka.gab2 + '&nbsp;cm' ).attr('align', 'right') );
        $row.append($td.clone().html( paczka.gab3 + '&nbsp;cm' ).attr('align', 'right') );

        $row.append($td.attr('align', 'center').append( $a_edit ).append($a_del) );

        return $row;
    }

/**************************************************************************************************/
    function templateOptions() {
        var $select = $przesylkaDialog.find('select[name=szablon]');
        var option = null, update = false;

        if( !DeltaCity.template_options ){
            DeltaCity.template_options = [];
        }

        if ( DeltaCity.templates && (!DeltaCity.template_options || DeltaCity.template_options.length == 0) ) {
            DeltaCity.options = [];

            for ( var o in DeltaCity.templates ) {
                if( typeof(DeltaCity.templates[o]) == 'object' ){
                    DeltaCity.template_options.push(o) ;
                }
            }

            update = true;
        }

        if ( !$select.val() ) {
            option = $przesylkaDialog.find('input[name=template]').val();
        }

        if ( option ) {
            var dodaj_opcje = true;
            for ( var i = 0; i < DeltaCity.template_options.length ; i++ ) {
                if ( DeltaCity.template_options[i] == option ) {
                    dodaj_opcje = false;
                    break;
                }
            }

            if( dodaj_opcje ){
                DeltaCity.template_options.push(option);
            }

            update = true;
        }

        if ( update ) {
            $select.children('option:gt(0)').remove();

            DeltaCity.template_options.sort();
            for ( var i = 0; i < DeltaCity.template_options.length ; i++ ) {
                $select.append('<option value="' + DeltaCity.template_options[i]+ '">' + DeltaCity.template_options[i] + '</option>');
            }
        }
    }

    function templateDelete( ){
        var tpl = $przesylkaDialog.find('select[name=szablon]').val();

        if ( !tpl ) {
            print_message( 'Wybierz szablon przesyki ktry chcesz usun' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': DeltaCity.url,
            'dataType':  'json',
            'data':  {'mode' : 'template', 'delete' : tpl},

            'success': function(data) {
                hideLoading();
                $przesylkaDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error && tpl && DeltaCity.templates[tpl] ) {
                    delete DeltaCity.templates[tpl];
                    DeltaCity.template_options = [];
                    templateOptions();
                }
            }
        }));

        return false;
    }

    function przesylkaCheckboxClick () {
        var $opcje = $('#' + this.id + 'Opcje');

        if ( this.checked ) {
            $opcje.find('input').removeAttr('disabled').removeAttr('readonly').removeClass('disabled');
            $opcje.find('label').removeClass('disabled');

            $opcje.slideDown();
        } else {
            $opcje.find('input').attr('disabled', 'disabled').attr('readonly', 'readonly').addClass('disabled');
            $opcje.find('label').addClass('disabled');

            $opcje.slideUp();
        }
    }

    function przesylkaKodChange( e, value, callback ) {
        if ( arguments.length == 1 && this ) {
            value = this.value;
            callback = przesylkaUpdateStacjaOdbioru;
        }

        if ( value.match(/^[0-9]{2}-[0-9]{3}$/) ){
            $.ajax({
                'url' : DeltaCity.url,
                'dataType':  'json',
                'data' : {
                    'mode' : 'placowka',
                    'kod' : value
                },

                'success' : function( data ){
                    //console.log(data.object);
                    if ( !data.error && data.object ) {
                        if ( typeof(callback) == 'function' ) {
                            callback(data.object);
                        }
                    }
                }
            });
        }
    }

    function przesylkaUpdateNadawca( kontrahent ){
        var f, pola = [ 'numer', 'nazwisko', 'imie', 'telKontakt', 'emailKontakt'], $form = $przesylkaDialog.find('form');

        for ( var i = 0; i < pola.length; i++ ) {
            f = pola[i];

            if ( $form[0].elements['nadawca[' + f + ']'] && kontrahent[f] ) {
                $form[0].elements['nadawca[' + f + ']'].value = kontrahent[f];
            }
        }

        przesylkaKodChange( null, kontrahent.kod, przesylkaUpdateStacjaNadania);
    }

    function przesylkaUpdatePlatnik( kontrahent ){
        var f, pola = [ 'numer', 'telKontakt'], $form = $przesylkaDialog.find('form');

        for ( var i = 0; i < pola.length; i++ ) {
            f = pola[i];

            if( $form[0].elements['platnik[' + f + ']'] && kontrahent[f] ){
                $form[0].elements['platnik[' + f + ']'].value = kontrahent[f];
            }
        }
    }

    function przesylkaUpdateOdbiorca( kontrahent ){
        var f, pola = [ 'numer', 'telKontakt'], $form = $przesylkaDialog.find('form');

        for ( var i = 0; i < pola.length; i++ ) {
            f = pola[i];

            if( $form[0].elements['platnik[' + f + ']'] && kontrahent[f] ){
                $form[0].elements['platnik[' + f + ']'].value = kontrahent[f];
            }
        }
    }

    function przesylkaUpdateStacjaOdbioru( placowka ){
        if ( placowka && placowka.symbol ){
            $przesylkaDialog.find('input[name=odb]').val(placowka.symbol);
        }
    }

    function przesylkaUpdateStacjaNadania( placowka ){
        if ( placowka && placowka.symbol ){
            $przesylkaDialog.find('input[name=nad]').val(placowka.symbol);
        }
    }

    function przesylkaTriggerHandlers() {
        $('#deltacityPrzesylkaUslugaSkladowanie').triggerHandler('click');
        $('#deltacityPrzesylkaZastrzDorNaDzien').triggerHandler('click');
        $('#deltacityPrzesylkaZastrzDorNaGodz').triggerHandler('click');
        $('#deltacityPrzesylkaBezpiecznaKoperta').triggerHandler('click');
        $('#deltacityPrzesylkaOdbiorcaKodPocztowy').triggerHandler('click');
    }

    var szablonChangeBusyState = false;
    function szablonOnChange( e ){
        if ( szablonChangeBusyState ){
            return;
        }
        szablonChangeBusyState = true;

        var data = {}, val = this.value, options = $przesylkaDialog.data('options');

        if ( options.dokument && options.dokument.id ) {
            przesylkaDokumentData( options.dokument.id, val );
        } else{
            if ( this.value && DeltaCity.templates[this.value] ) {
                data = DeltaCity.templates[this.value];
            }

            formSetValues(this.form, data, { 'clear' : true });
            if( data.paczki && data.paczki.length ) {
                DeltaCity.paczki  = data.paczki;
            } else {
                DeltaCity.paczki  = [];
            }
            deltacityPaczkiPrint();

            this.value = val;
            przesylkaTriggerHandlers();
        }

        szablonChangeBusyState = false;

        return true;
    }

    var przesylkaDokumentDataBusyState = false;
    function przesylkaDokumentData ( id, template ) {
        if ( przesylkaDokumentDataBusyState ){
            return;
        }

        if ( id > 0 && typeof(template) == 'string' && template != '' ){
            przesylkaDokumentDataBusyState = true;

            $activeDialog = $przesylkaDialog;
            $przesylkaDialog.dialog('disable');

            $.ajax($.extend({}, settingsAjax, {
                'url': DeltaCity.url,
                'dataType':  'json',
                'data':  {
                    'mode' : 'przesylka',
                    'id' : id,
                    'template' : template,
                    'doc_type' : $przesylkaDialog.find('input[name=doc_type]').val()
                },

                'success': function(data) {
                    hideLoading();
                    $przesylkaDialog.dialog( "enable" );
                    przesylkaDokumentDataBusyState = false;

                    print_message( data );

                    if ( !data.error ) {
                        var $form = $przesylkaDialog.find('form');
                        formSetValues( $form[0], data.object.przesylka, { 'clear' : $form.find('input,select').not('[name=szablon]').not('[type=hidden]') } );

                        if ( data.object.przesylka.paczki  ) {
                            if( data.object.przesylka.paczki.paczka ) {
                                if ( data.object.przesylka.paczki.paczka.lenght && data.object.przesylka.paczki.paczka[0] ) {
                                    DeltaCity.paczki = data.object.przesylka.paczki.paczka
                                } else if ( data.object.przesylka.paczki.paczka.typ && data.object.przesylka.paczki.paczka.waga ) {
                                    DeltaCity.paczki = [];
                                    DeltaCity.paczki.push(data.object.przesylka.paczki.paczka);
                                }
                            } else {
                                DeltaCity.paczki = [];
                            }
                        } else {
                            DeltaCity.paczki = [];
                        }
                        deltacityPaczkiPrint();

                        przesylkaDokumentInfo(data.object.dokument);
                    }
                }
            }));
        }
    }

    function przesylkaDokumentInfo( dokument ){
        var html = '<div class="head">Informacja o dokumencie</div>';
        var doc = jQuery.extend({}, dokument ? dokument : {});

        if ( doc.PLN_WARTOSC_NETTO ) {
            doc.PLN_WARTOSC_NETTO = currency_format(doc.PLN_WARTOSC_NETTO) + ' PLN';
        }

        if ( doc.PLN_WARTOSC_BRUTTO ) {
            doc.PLN_WARTOSC_BRUTTO = currency_format(doc.PLN_WARTOSC_BRUTTO) + ' PLN';
        }

        html += print_object( '#deltacityPrzesylkaDokumentTemplate', doc );
        $('#deltacityPrzesylkaDokument').html( html ).slideDown();
    }

    function przesylkiDokumentyHTML( $dokumenty ) {
        $dokumenty.html('<div class="head">Wybrane dokumenty</div>').show();

        if ( docSelection.selected.length > 0 ) {
            var warning, warnings = false, r = null;

            var $ul = $('<ol class="lista"></ol>');
            for ( r in docSelection.records ){
                warning = '';
                if ( docSelection.records[r].numer_przesylki && docSelection.records[r].numer_przesylki != '' ) {
                    warning = 'Uwaga! Dla tego dokumentu zostaa ju stworzona przesyka o numerze: ' + docSelection.records[r].numer_przesylki + ' w systemie WebMobile7';
                }

                $ul.append( '<li class="item doc-numer">' + docSelection.records[r].numer + ( warning ? ' <span class="warning" title="'+warning+'" style="float: none; vertical-align:middle">&nbsp;</span>' : '') + '</li>' );

                if ( warning ) warnings = true;
            }

            $dokumenty.append($ul);

            $ul.find('.warning').tooltip().button({
                'icons' : {
                    'primary' : 'ui-icon-alert'
                },
                'text' : false
            });

            if ( warnings ) {
                print_message('Uwaga dla czci wybranych dokumentw nie moe zosta stworzona przesylka. Dla dokumentw przy ktrych wywitlaj si ostrzeenia nie zostan utworzone przesyki. Sprawd ostrzeenia wywietlane przy numerze dokumentu');
            }
        } else {
            sprawdzWybraneDokumenty();
        }
    }

    function przesylkaOpen ( e ) {
        e.preventDefault();

        var options = {};
        var $this = $(this);

        options.template = this.id.indexOf('Szablon') > -1;
        options.multiple = this.id.indexOf('Przesylki') > -1;
        options.dokument = {};

        if ( !options.multiple && !options.template ) {
            options.dokument = $this.parents('tr').metadata(metadataOptions);
        }

        if ( !$przesylkaDialog ) {
            $przesylkaDialog = $('#deltacityPrzesylkaDialog').dialog( $.extend({},dialogOptions, {
                'maxWidth': 1400,
                'width' : 1100
            }));

            $przesylkaDialog.find('input[type=submit]').hide();
            $przesylkaDialog.find('a.search-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-search'
                },
                'text' : false
            }).click(kontrahentOpen);

            $('#deltacityPrzesylkaZastrzDorNaDzien').click(przesylkaCheckboxClick);
            $('#deltacityPrzesylkaZastrzDorNaGodz').click(przesylkaCheckboxClick);
            $('#deltacityPrzesylkaOdbiorcaKodPocztowy').change(przesylkaKodChange);
            $('#deltacityPrzesylkaSzablon').change( szablonOnChange );

            $przesylkaDialog.find('form').submit(przesylkaSave);

            templateOptions();
        }

        //resetuje paczki
        DeltaCity.paczki  = [];
        deltacityPaczkiPrint();

/**************************************************************************************************/
        var przesylkaOptions = {
            'title' : this.title
        };

        przesylkaOptions.buttons = [];
        przesylkaOptions.buttons = [
            {
                'text': "Anuluj",
                'icons' : {'primary' : 'ui-icon-cancel'},
                'click': function() {$(this).dialog("close");}
            },
            {
                'text': "Paczka",
                'icons' : {'primary' : 'ui-icon-plus'},
                'click': deltacityPaczkaDodaj
            }
        ];

        if ( options.template ) {
            przesylkaOptions.buttons.push({
                'text': "Usu",
                'icons': {primary : 'ui-icon-trash'},
                'click': templateDelete
            });

            przesylkaOptions.buttons.push({
                'text': "Zapisz",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {$(this).find("form").submit();}
            });
        } else {
            przesylkaOptions.buttons.push({
                'text': "Ok",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {$(this).find("form").submit();}
            });
        }

        $przesylkaDialog.dialog('option', przesylkaOptions );
        $przesylkaDialog.data('options', options);

/**************************************************************************************************/

        if ( options.dokument && options.dokument.id ) {
            var zki = options.dokument.index;

            if ( DeltaCity.docs[zki] && DeltaCity.docs[zki].przesylka ) {
                var $form = $przesylkaDialog.find('form');
                var tpl = $('#deltacityPrzesylkaSzablon').val();

                if ( tpl ) {
                    przesylkaDokumentData(options.dokument.id, tpl );
                } else {
                    var $fields = $form.find('input,select').not('[type=hidden]').not('[name=szablon]');
                    formSetValues ( $form[0], {'odbiorca' : DeltaCity.docs[zki].przesylka.odbiorca}, { 'clear' : $fields } );

                    przesylkaDokumentInfo( DeltaCity.docs[zki] );
                    print_message('Wybierz szablon przesyki aby utworzy przesyk wedug zapsanego schematu, albo wypenij samodzielnie dane do przesyki.');
                }
            }
        } else {
            $('#deltacityPrzesylkaDokument').hide().html('');
            $('#deltacityPrzesylkaSzablon').triggerHandler('change');
        }


        if ( options.multiple || options.template ){
            $przesylkaDialog.find('.template0').hide();
            $przesylkaDialog.find('.template1').show();

            if ( options.multiple ){
                $przesylkaDialog.find('.multi0').hide();
            } else {
                $przesylkaDialog.find('.multi0').show();
            }

        } else {
            $przesylkaDialog.find('.template0, .multi0').show();
            $przesylkaDialog.find('.template1, .multi1').hide();
            $('#deltacityPrzesylkaTemplate').hide();

        }

        var $zamowienia = $przesylkaDialog.find('.zamowienia');
        if ( options.multiple ) {
            przesylkiDokumentyHTML($zamowienia);
        } else {
            $zamowienia.html('').hide();
        }

        var teraz = new Date();
        $('#deltacityPrzesylkaPotwierdzenieData').val( teraz.getFullYear() + '-' +  num_pad2(teraz.getMonth() + 1) + '-' + num_pad2(teraz.getDate()) + ' ' + num_pad2(teraz.getHours()) + ':' + num_pad2(teraz.getMinutes()) );

        $przesylkaDialog.dialog('open');

        przesylkaTriggerHandlers();

        return false;
    }

    function num_pad2( n ) {
        return ( n < 10 ) ? '0' + n : n;
    }

    function przesylkiCheckZamowienia( form ) {
        if ( !sprawdzWybraneDokumenty() ) {
            return false;
        }

        var items = [];
        for ( r in docSelection.records ){
            if ( !docSelection.records[r].numer_przesylki || docSelection.records[r].numer_przesylki == '' ) {
                items.push( r );
            }
        }

        if ( items.length == 0 ) {
            print_message('Nie mona wysa formularza poniewa dla wybranych dokumentw przesyki zostay ju utworzone');
            return false;
        }

        docSelection.appendTo(form, {'selected' : items} );

        return true;
    }

    function przesylkaSave() {
        var options = $przesylkaDialog.data('options');
        var $form  = $(this);

        if ( options.template ){
            $( 'input[name=mode]', this ).val( 'template' );
        } else if ( options.dokument && options.dokument.id ){
            $( 'input[name=mode]', this ).val( 'przesylka' );
        } else{
            $( 'input[name=mode]', this ).val( 'przesylki' );
        }

        if ( options.multiple ){
            if ( !przesylkiCheckZamowienia(this) ) {
                return false;
            }
        } else if ( options.dokument ){
           $form.find('input[name^=selected]').remove();
           $form.append('<input type="hidden" name="selected[]" value="' + options.dokument.id + '" />');
        }

        var $status = $('#deltacityPrzesylkaOpcjeZamowienieStatus');
        var status_id = $status.val(), status = null;
        if ( status_id ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        }

        showLoading();
        $przesylkaDialog.dialog('disable');
        $activeDialog = $przesylkaDialog;

/**************************************************************************************************/
        var uslugi = {};
        var some_data = $form.find("input[type=checkbox]").map(function(){
            return {'name': $(this).attr('name'), 'value': ( this.type && this.type == 'checkbox' ) ? (this.checked ? this.value : '0') : $(this).val()};
        }).get();

        for ( var i = 0; i < some_data.length; i++  ) {
            if ( some_data[i].name ) {
                uslugi[some_data[i].name] = some_data[i].value;
            }
        }
        uslugi = object_deflatte( uslugi );

/**************************************************************************************************/

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',
            data: uslugi,
            success: function(data){
                hideLoading();
                $przesylkaDialog.dialog( "enable" );

                if ( options.template ){
                    print_message( data );

                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        var template = data.object;
                        if ( !DeltaCity.templates ){
                            DeltaCity.templates = new Object();
                        }
                        DeltaCity.templates[template.template] = template;

                        //aktualizuje opcje dla template
                        templateOptions();

                        $przesylkaDialog.dialog("close");
                        $activeDialog = null;
                    }
                } else {
                    print_message( data.message );

                    if ( !data.error && data.object && data.object.length ) {
                        var $doc_row, doc, dokument = null;
                        //console.log(data.object);
                        for( var i = 0; i < data.object.length; i++ ){
                            dokument = data.object[i];

                            if ( dokument.przesylka ) {
                                $doc_row = $('#doc' + dokument.ID + '_row');

                                if ( $doc_row.length ) {
                                    doc = $doc_row.metadata(metadataOptions);
                                    doc.numer_przesylki = dokument.przesylka.nrPrzesylki;
                                    $doc_row.attr('data', JSON.stringify(doc));
                                }
                                $doc_row.find('.przesylka-btn').remove();
                                $doc_row.find('.wydruk-btn, .etykieta-btn').show();

                                $doc_row.find('.przesylka-numer').html( dokument.przesylka.nrPrzesylki );

                                if ( status ) {
                                    $doc_row.find('.zk-status').html( status );
                                }
                            }
                        }
                    }

                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        $przesylkaDialog.dialog("close");
                        $activeDialog = null;
                    }
                }
            }
        }));

        return false;
    }

/**************************************************************************************************/
    function eksportOpen ( e ) {
        e.preventDefault();

        if ( !$eksportDialog ) {
            $eksportDialog = $('#deltacityEksportXLSDialog').dialog( $.extend({},dialogOptions, {
                'maxWidth': 1400,
                'width' : 1100,
                'title' : this.title,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Eksport",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $eksportDialog.find('input[type=submit]').hide();
            $eksportDialog.find('a.search-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-search'
                },
                'text' : false
            }).click(kontrahentOpen);

            $eksportDialog.find('form').submit(eksportSave);
        }

        przesylkiDokumentyHTML($eksportDialog.find('.zamowienia'));
        $eksportDialog.dialog('open');

        return false;
    }

    function eksportSave() {
        var $form  = $(this);

        if( !przesylkiCheckZamowienia( $form ) ){
            return false;
        }

        showLoading();
        $eksportDialog.dialog('disable');
        $activeDialog = $eksportDialog;

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $eksportDialog.dialog( "enable" );

                print_message( data.message );

                if ( !data.error ) {
                    //jeszcze zostanie aktualizacja numeru eksportu wydania przy zamwieniach
                    $eksportDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }

/**************************************************************************************************/

    function setupTable( target ){
        $('.przesylka-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-transfer-e-w'
            },
            'text' : false
        }).click(przesylkaOpen);

        $('.wydruk-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-print'
            },
            'text' : false
        });

        $('.etykieta-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-tag'
            },
            'text' : false
        });

        $('.status-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-info'
            },
            'text' : false
        }).click( function(e){
            e.preventDefault();

            var zk = $(this).parents('tr').metadata(metadataOptions);
            if ( !zk.numer_przesylki || zk.numer_przesylki == '' ){
                print_message('Dla dokumentu ' + zk.numer + ' nie mona sprawdzi statusu paczki, poniewa nie zostaa wygenrowana przesyka.');
                return false;
            }

            $dialog.dialog( 'option', 'title', 'Statusy przesyki dla dokumentu: ' + zk.numer);

            $.ajax($.extend({},settingsAjax, {
                'url' : this.href,
                'dataType':  'html',
                'async' : false,
                'success' : function ( data ) {
                    //jeli odpwiedz jest w json to moliwe wystpi jaki bd
                    var json = str2obj(data);
                    if ( json.message ) {
                        print_message(json.message);
                        return false;
                    }
                    //wywietlam statursy przesyki
                    $dialog.html(data);

                    $dialog.dialog('open');
                }
            }));

            return false;
        });

        $('.dokument-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-document'
            },
            'text' : false
        }).click( function(e){
            try{}catch(e){}

            var href = this.href;
            var zk = $(this).parents('tr').metadata(metadataOptions);
            if ( !zk ) zk = {};

            if ( !zk.numer_przesylki || zk.numer_przesylki == '' ) {
                e.preventDefault();
                print_message('Dla dokumentu: ' + zk.numer + ' nie mona pobra dokumentu wydania poniewa nie zosta jeszcze wygenerowany numer listu przewozowego');
                return false;
            }

            if ( !zk.dokument || zk.dokument == '' ) {
                e.preventDefault();

                confirmDialog ( 'Dla dokumentu ' + zk.numer + ' nie jest przypisany numer dokumentu wydania, ale moesz sprawdzi czy list przewozowy o numerze ' + zk.numer_przesylki + ' znajduje si ju na jakim dokumencie wydania?', {
                    'confirm' : function(){
                        window.location = href;
                    }
                });

                return false;
            }

            return true;
        });
    }

    $(function(){
        $dialog = $('#deltacityDialog').dialog(dialogOptions);

        setupTable( document );

        docSelection = new EcSelection('deltacityContent', {
            'target' : 'docsList',
            'setup' : setupTable,
            'metadata' : metadataOptions
        });

        $('#deltacityApiConfigBtn').button({
            'icons' : {
                'primary' : 'ui-icon-gear'
            },
            'text' : false
        }).click(settingsOpen);

        $('#deltacityUtworzDokumentWydania').click(dokumentOpen);

        $('#deltacityNadajPrzesylki').click(przesylkaOpen);
        $('#deltacityPrzesylkaSzablonButton').click(przesylkaOpen);
        $('#deltacityEksportXLSButton').click(eksportOpen);
        $('#deltacityZamowieniaStatusyButton').click(zkStatusOpen);

        $('#deltacityDrukujPrzesylki,#deltacityEtykietyPrzesylki').click(function(e){
            e.preventDefault();

            if ( !sprawdzWybraneDokumenty() ) return false;

            var selected = [];
            for ( var a in docSelection.records ) {
                if ( docSelection.records[a].numer_przesylki ) {
                    selected.push(docSelection.records[a].numer_przesylki);
                }
            }

            if ( selected.length  == 0 ) {
                print_message('Dla wybranych dokumentw nie zostay jeszcze utworzone przesyki i nie mona wydrukowa listw przewozowych/etykiet');
                return false;
            }

            var $form = $('#deltacityForm');
            $form.attr('action', this.href);
            $form.find('input[name^=selected]').remove();
            for ( var i = 0 ; i < selected.length ; i++ ) {
                $form.append('<input type="hidden" name="selected[' + i  + ']" value="' + selected[i] + '" />');
            }
            $form[0].submit();

            return false;
        });

        $('.template').hide();
        $('.placeholder').textPlaceholder();
        $('a[title].help').tooltip();
        $('a[rel].help').click(function(e){
            $( this.rel.substr(0,1) == '#' ? this.rel : '#' + this.rel ).slideToggle('slow');
            return false;
        });
    });
})();



