/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Funkcja ustawiajca dane towaru do oferty specjalnej dla edytowanego produktu, po wybraniu go z okna wyszukiwania produktw
 *
 * @returns {undefined}
 */
function ofertaSpecAassignTowar(towarId, towarNazwa) {
    //console.log(arguments);
    $('#ofertaSpecOfertaId').val(towarId);
    $('#ofertaSpecOfertaNazwa').val(towarNazwa);

    //jeszcze pobieram informacje o vacie, dla produktu
    $.get(SELF_URL + '?action='+ ACTION_TOWARY + '&json=1&mode=' + MODE_AJAX + '&ID=' + towarId, function(json){
        try{
            var towar = str2obj(json);
            //przypisuje VAT dla ukrytego pola
            $('#ofertaSpecOfertaVat').val(towar.VAT);
        }catch( e ) {
            console.log(e);
        }
    });
}

/**
 *
 * @param integer id
 * @param string nazwa
 * @returns {undefined}
 */
function ofertaSpecAassignContactExtGroup( id, nazwa ){
    $('#ofertaSpecContactExtGroupId').val(id);
    $('#ofertaSpecContactExtGroupName').val(nazwa);
}


(function($){
    //aktualne progi cenowe
    var $element;
    var $ofertaSpecDialog;
    var $ofertaSpecContactTreeInitBtn;
    var ofertaSpecIndex = -1;

    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function ofertySpecInit(options){
        $element = $(options.target);

        if ( $element.data ( 'ecOfertySpecOptions') ){
            return false;
        }

        //zapisuje opcje do przycisku
        $element.data ( 'ecOfertySpecOptions', options );

        /**
         * Tabela progw
         */
        var $table = $('<table class="grid" width="100%" border=0 cellspacing=0 cellpading=5>' + "\n" +
                '<tr>' + "\n" +
                    '<th width="15px">Lp.</th>' + "\n" +
                    '<th width="80px">Modu</th>' + "\n" +
                    '<th >Nazwa towaru</th>' + "\n" +
                    '<th width="100px">Od</th>' + "\n" +
                    '<th width="100px">Do</th>' + "\n" +
                    '<th width="150px">Cena specjalna</th>' + "\n" +
                    '<th width="100px">Akcje</th>' + "\n" +
                 '</tr>' + "\n" +
            '</table>');

        $element.append($table);

        if ( options.items ) {
            printTable( $element.find('table'), options.items );
        }
    }

    function floatval( val ){
        if ( typeof(val) == 'string' ) {
            val = val.replace(',', '.').replace(/\s+/, '');
        }

        var num = parseFloat(val);
        if ( isNaN(num) ) {
            num = 0;
        }

        return num;
    }

    function ofertaSpecZapisz( e ){
        if( e && typeof(e.preventDefault) == 'function' ) e.preventDefault();

        var options = $element.data('ecOfertySpecOptions');
        var items = options.items;

        var errors = {};
        var item = null;

        if (ofertaSpecIndex >= 0 && ofertaSpecIndex < items.length) {
            item = items[ofertaSpecIndex];
        } else {
            item = {
                id: null,
                oferta_id: null,
                oferta_nazwa: null,
                oferta_vat: null,
                contact_ext_group_id: null,
                contact_ext_group_name: null,
                cena_id: null,
                waluta_id: null,
                waluta_kod: null,
                cena_netto: null,
                cena_brutto: null
            };
        }

        item.oferta_id  = floatval($ofertaSpecDialog.find('input[name=oferta_id]').val());
        item.oferta_vat = floatval($ofertaSpecDialog.find('input[name=oferta_vat]').val());
        item.oferta_nazwa = $ofertaSpecDialog.find('input[name=oferta_nazwa]').val();

        var $ec_konto = $ofertaSpecDialog.find('select[name=ec_konto]');
        item.ec_konto = floatval($ec_konto.val());
        item.ec_modul = $ec_konto[0].options[$ec_konto[0].selectedIndex].text;

        item.contact_ext_group_id =$ofertaSpecDialog.find('input[name=contact_ext_group_id]').val();
        item.contact_ext_group_name =$ofertaSpecDialog.find('input[name=contact_ext_group_name]').val();

        //daty obowizywania
        item.oferta_od = $ofertaSpecDialog.find('input[name=oferta_od]').val().trim();
        item.oferta_do = $ofertaSpecDialog.find('input[name=oferta_do]').val().trim();

        if ( item.oferta_od && !item.oferta_od.match(/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/)) {
            errors.oferta_od = "Nieprawidowy foramt daty od kiedy ma obowizywa oferta specjalna dla produktu: \"" + options.towar_nazwa + "\".";
        }

        if ( item.oferta_do && !item.oferta_do.match(/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/)) {
            errors.oferta_do = "Nieprawidowy format daty do kiedy ma obowizywa oferta specjalna dla produktu: \"" + options.towar_nazwa + "\".";
        }

        if ( item.oferta_od && item.oferta_do && item.oferta_od > item.oferta_do ) {
            errors.oferta_od = "Data od kiedy ma obowizywa oferta jest starsza od daty do kiedy ma obowizywa oferta specjalna dla produktu: \"" + options.towar_nazwa + "\"";
        }

        if ( item.oferta_id ) {
            for ( var i = 0; i < items.length; i++ ) {
                if ( i != ofertaSpecIndex && (items[i].oferta_id == item.oferta_id) && ((items[i].ec_konto == -1) || (item.ec_konto == -1) || (item.ec_konto == items[i].ec_konto) ) ) {
                    //sprawdzam czy daty si nakadaj
                    if ( (item.oferta_do && items[i].oferta_od && item.oferta_do < items[i].oferta_od) || (item.oferta_od && items[i].oferta_do && item.oferta_od > items[i].oferta_do) ) {
                        //tutaj jest dobrze okresy si na siebie nie nakadaj i mona puci

                    } else {
                        errors.oferta_nazwa = "Produkt: " + item.oferta_nazwa + " zosta zdefiniowany ju jako oferta specjalna dla towaru: \"" + options.towar_nazwa + "\".";
                        break;
                    }
                }
            }

            //jeli utkownik prbuje przypisa ten sam produkt dla siebie jako ofert specjaln poinformuj o bdzie
            if ( item.ofert_id == options.towar_id ) {
                errors.oferta_nazwa = 'Nie moesz przypisa tego samego produku dla samego siebie jako ofert spejaln.';
            }
        } else {
            errors.oferta_nazwa = "Wybierz produkt, ktry bdzie mona kupi na preferencyjnych warunkach przy zakupie towaru \"" + options.towar_nazwa + "\".";
        }

        var $cena_id = $ofertaSpecDialog.find('select[name=cena_id]');
        item.cena_id = floatval($cena_id.val());
        item.cena_nazwa = $cena_id[0].options[$cena_id[0].selectedIndex].text;

        //jeli brak ceny to sprawdzam czy zostaa podana cena w formularzu
        if ( !item.cena_id ) {
            //przypisuje walut
            var $waluta_id = $ofertaSpecDialog.find('select[name=waluta_id]');
            item.waluta_id = floatval($waluta_id.val());
            item.waluta_kod = $waluta_id[0].options[$waluta_id[0].selectedIndex].text;

            //przypisuje ceny netto i brutto ustalone dla produktu
            item.cena_netto = floatval($ofertaSpecDialog.find('input[name=cena_netto]').val());
            item.cena_brutto = floatval($ofertaSpecDialog.find('input[name=cena_brutto]').val());

            if ( item.cena_netto > item.cena_brutto ) {
                errors.cena_netto = "Cena netto dla produktu w ofercie specjalnej nie moe by mniejsza od ceny brutto.";
            }

            //jeli brak jest ceny netto lub brutto dla oferty specjalnej i nie zostaa cena brutto
            if ( !item.cena_netto || !item.cena_brutto ) {
                errors.cena_id = "Wybierz cen, ktra bdzie obowizywaa dla oferty specjalnej lub wpisz cen netto i brutto produktu.";
            }
        }


        if ( errors.oferta_nazwa || errors.cena_id || errors.cena_netto || errors.oferta_do || errors.oferta_do ) {
            var msg = '';
            if ( typeof($.validator) != 'undefined' ) {
                $ofertaSpecDialog.find('form').validate().showErrors( errors );
            } else {
                msg += "\n";
                for( var e in errors ){
                    msg += errors[e] + "\n";
                }
            }

            //wywietlam komunikaty o bdach
            alert('Popraw nastpujce bdy: '  + "\n" + msg );
        } else {
            if ( ofertaSpecIndex < 0 || ofertaSpecIndex >= items.length ) {
                $element.find('table').append(printTableRow(item, options.items.length+1) ) ;
                options.items.push(item);
            } else {
                $element.find('tr:eq('+(ofertaSpecIndex+1)+')').replaceWith( printTableRow ( item,  ofertaSpecIndex+1 ) );
                options.items[ofertaSpecIndex] = item;
            }

            $element.data('ecOfertySpecOptions', options);
            $ofertaSpecDialog.dialog('close');

            //zapisuje oferty specjalne w polach ukrytych
            ofertySpecjalneZapisz();
        }

        return false;
    }

    /**
     * funkcja ustawiajca walut dla ceny specjalnej
     *
     * @returns {undefined}
     */
    function ofertaSpecWalutaChangeHandler(){
        try{
            var waluta = this.options[this.selectedIndex].text;
            $ofertaSpecDialog.find('span.waluta').text(waluta);
        }catch( e ) {
            console.log(e);
        }
    }

    /**
     * Funkcja pokazujca/ukrywajca pola do wpisania samodzielnie ceny specjalnej dla produktu bdcego
     * w ofercie specjalnej do edytowanego produktu
     *
     * @returns {undefined}
     */
    function ofertaSpecCenaChangeHandler(){
        if ( this.value > 0 ) {
            $ofertaSpecDialog.find('.cena-param').hide();
        } else {
            $ofertaSpecDialog.find('.cena-param').show();
        }
    }


    function ofertaSpecExKontoChangeHandler() {
        if (this.value > 0) {
            $ofertaSpecDialog.find('#ofertaSpecContactExtGroup').show();
        } else {
            $ofertaSpecDialog.find('#ofertaSpecContactExtGroup').hide();
        }
    }
    /**
     * Funkcja obsugujca opuszczenia pola z cen netto w formularzu oferty specjalnej
     *
     * @returns {undefined}
     */
    function ofertaSpecCenaNettoBlurHandler(){

        var $nie_przeliczaj = $('#ofertaSpecNiePrzliczajCen');
        //jeli jest zaznaczony checkbox, aby nie przelicza ceny netto i brutto, przy opuszczaniu pola
        if ( $nie_przeliczaj.length && $nie_przeliczaj[0].checked ) {
            return false;
        }

        var val = this.value.replace(',', '.').replace(/\s+/, '');

        //jeli nie ma wpisanej wartoci to wychodz
        if ( !val ) {
            return false;
        }

        var cena = parseFloat(val);
        if ( isNaN(cena) ) {
            return false;
        }

        //pobieram informacj o vacie dla produktu w ofercie specjalnej
        var oferta_vat = floatval($('#ofertaSpecOfertaVat').val());

        var cena_brutto = cena * (1 + oferta_vat/100);

        //przypisuje cene brutto dla pola
        $('#ofertaSpecCenaBrutto').val(cena_brutto.toFixed(2));
    }

    /**
     * Funkcja obsugujca opuszczenie pola z cen brutto w formularzu oferty specjalnej
     *
     * @returns {undefined}
     */
    function ofertaSpecCenaBruttoBlurHandler(){

        var $nie_przeliczaj = $('#ofertaSpecNiePrzliczajCen');
        //jeli jest zaznaczony checkbox, aby nie przelicza ceny netto i brutto, przy opuszczaniu pola
        if ( $nie_przeliczaj.length && $nie_przeliczaj[0].checked ) {
            return false;
        }

        var val = this.value.replace(',', '.').replace(/\s+/, '');

        //jeli nie ma wpisanej wartoci to wychodz
        if ( !val ) {
            return false;
        }

        var cena = parseFloat(val);
        if ( isNaN(cena) ) {
            return false;
        }

        //pobieram informacj o vacie dla produktu w ofercie specjalnej
        var oferta_vat = floatval($('#ofertaSpecOfertaVat').val());

        var cena_netto = cena / (1 + oferta_vat/100);
        //przypisuje obliczon cen dla pola z cen netto
        $('#ofertaSpecCenaNetto').val(cena_netto.toFixed(2));
    }

    /**
     * Funkcja otwierajca okno dialogowe
     *
     * @param {type} item
     * @returns {Boolean}
     */
    function ofertaSpecDialogOpen ( item ) {

        if( !$ofertaSpecDialog ){
            var options = $element.data('ecOfertySpecOptions');

            $ofertaSpecDialog  = $('#ofertaSpecDialog').dialog({
                'open' : false,
                'width' : 800,
                'height' : 500,
                'title' : options.title ? options.title : 'Oferta specjalna dla towaru: ' + options.towar_nazwa,
                'buttons' : {
                    'Anuluj' : function(){
                        $ofertaSpecDialog.dialog('close');
                    },

                    'OK' : ofertaSpecZapisz
                }
            });


            //dodaje autocomplete'a na polu z nazw produktu bdcego ofert specjaln dla edytowanego towaru
            $ofertaSpecDialog.find('input[name=oferta_nazwa]').autocomplete({
                source: SELF_URL + '?action='+ ACTION_TOWARY + '&mode=autocomplete',
                minLength: 2,
                select: function( event, ui ) {
                    //przypisuje id produktu, ktry bdzie w ofercie specjalnej do tego towaru
                    $('#ofertaSpecOfertaId').val(ui.item.id);
                    //przypisuje VAT dla ukrytego pola
                    $('#ofertaSpecOfertaVat').val(ui.item.vat);
                    //przypisuje VAT dla ukrytego pola
                    $('#ofertaSpecOfertaNazwa').val(ui.item.value);
                    //debuguje zwrcone dane
                    //console.log(ui.item);
                    //console.log( "Selected: " + ui.item.value + " aka " + ui.item.id );
                }
            });

            $ofertaSpecDialog.find('select[name=ec_konto]').change(ofertaSpecExKontoChangeHandler);
            $ofertaSpecDialog.find('select[name=cena_id]').change(ofertaSpecCenaChangeHandler);
            $ofertaSpecDialog.find('select[name=waluta_id]').change(ofertaSpecWalutaChangeHandler);

            $ofertaSpecDialog.find('input[name=cena_netto]').blur(ofertaSpecCenaNettoBlurHandler);
            $ofertaSpecDialog.find('input[name=cena_brutto]').blur(ofertaSpecCenaBruttoBlurHandler);

            $ofertaSpecContactTreeInitBtn = jQuery('#ofertaSpecContactExtTree a').clone();
            $ofertaSpecContactTreeInitBtn.click(function(e){
                if (e && e.preventDefault) {
                    e.preventDefault();
                }

                var url = jQuery('#ofertaSpecContactExtTree').attr('data-tree-url');
                tree_init(this, url.replace('%gid%', jQuery('#ofertaSpecContactExtGroupId').val()));

                return false;
            });

            $ofertaSpecDialog.find('input[type=submit]').hide();
            $ofertaSpecDialog.find('form').submit(ofertaSpecZapisz);

            //ustawiam polski jzyk w datepickerze
            jQuery.datepicker.setDefaults(jQuery.datepicker.regional['pl']);

            //inicjuje daty
            $ofertaSpecDialog.find('input.date-input').datepicker({
                dateFormat: 'yy-mm-dd' ,
                showAnim: 'fadeIn',
                showOn: 'both',
                buttonImage: SZABLON_URL + "/images/buttons/cal.gif",
                buttonImageOnly: true,
                buttonText: "Wybierz dat"
            });
        }

        //jeli nie mamy formularza dodawania ofert specjalnych to wywietlam bd
        if ( !$ofertaSpecDialog.length ) {
            //resetuje ustawinia
            alert('Brak okienka dialogowego do dodawania ofert specjalnych dla produktu');
            return false;
        }

        $ofertaSpecDialog.find('input[type=text],select').val('');
        if ( item ) {
            for ( var a in item ) {
                $ofertaSpecDialog.find('input[name=' + a + ']').val(item[a]);
                $ofertaSpecDialog.find('select[name=' + a + ']').val(item[a]);
            }
        }

        $ofertaSpecDialog.find('select[name=ec_konto]').triggerHandler('change');
        $ofertaSpecDialog.find('select[name=waluta_id]').triggerHandler('change');
        $ofertaSpecDialog.find('select[name=cena_id]').triggerHandler('change');

        jQuery('#ofertaSpecContactExtTree').html('');
        $ofertaSpecContactTreeInitBtn.clone(true).appendTo('#ofertaSpecContactExtTree');

        //odznaczam checkbox, do przeliczania cen
        var $nie_przeliczaj = $('#ofertaSpecNiePrzliczajCen');
        if ( $nie_przeliczaj.length ) {
            $nie_przeliczaj[0].checked = false;
        }

        $ofertaSpecDialog.dialog('open');
    }

    /**
     * Funkcja odpowiedzialna za dodawanie oferty specjalnej dla produktu.
     *
     * @returns {undefined}
     */
    function ofertaSpecDodaj () {
        ofertaSpecIndex = -1;

        ofertaSpecDialogOpen();
    }

    /**
     * Funkcja odpowiedzialna za edycj oferty specjalnej dla produktu.
     *
     * @param {type} e
     * @returns {Boolean}
     */
    function ofertaSpecEdytuj ( e ) {
        e.preventDefault();
        $element = $(this).parents('table:first').parent();

        var $tr = $(this).parents('tr');
        ofertaSpecIndex = $tr.index() - 1;

        var options = $element.data('ecOfertySpecOptions');
        ofertaSpecDialogOpen( options.items[ofertaSpecIndex] );

        return false;
    }

    /**
     * Funkcja odpowiedzialna za usunicie oferty specjalnej dla produktu, wkonywana po klikniciu na przycisk usuwania
     *
     * @param {type} e
     * @returns {Boolean}
     */
    function ofertaSpecUsun ( e ) {
        e.preventDefault();

        var $tr = $(this).parents('tr:first');
        var $table = $tr.parents('table:first');

        $element = $table.parent();
        var options = $element.data('ecOfertySpecOptions');

        if ( confirm('Jeste pewien, e chcesz usun ofert specjaln dla towaru: "' + options.towar_nazwa + '"?') ) {

            var i = $tr.index() - 1;
            options.items.splice( i, 1);

            $element.data('ecOfertySpecOptions', options);

            $tr.remove();

            $table.find('tr:gt(0)').each(function( i, el ){
                $(el).attr('class', ((i+1) % 2)  ? 'odd' : 'even');
                $(el).find('td.num').html( (i + 1) + '.');
            });

            //zapisuje
            ofertySpecjalneZapisz(options);
        }

        return false;
    }

    function printTable( $table, items ) {
        var rows = $table.find('tr');

        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        if ( items ) {
            for ( var i = 0; i < items.length; i++ ){
                $table.append( printTableRow(items[i], i+1) );
            }
        }

        ofertySpecjalneZapisz();
    }

    /**
     *  Funkcja wywietla pojedyczy wiersz oferty specjalnej dla towaru
     *
     * @param {type} item
     * @param {type} lp
     * @returns {Arguments|Element|document.all|HTMLDocument.all|Document.all|window.document.all|Node.all|window.$.e|window.$|$|Array|window.$.elements}
     */
    function printTableRow (item, lp) {

        var $row = $('<tr>');
        if ( lp % 2 == 1 ) {
            //$row.addClass('odd');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(ofertaSpecUsun);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(ofertaSpecEdytuj);

        var $td = $('<td>');

        $row.append($td.clone().html( lp + '. ' ).attr('align', 'right').addClass('num'));

        //jeli brak moduu ustawiam
        if (!item.ec_modul) {
            var $ec_konto = $('#ofertaSpecEcKonto');
            if ($ec_konto.length) {
                for(var o in $ec_konto[0].options) {
                    if ($ec_konto[0].options[o].value == item.ec_konto) {
                        item.ec_modul = $ec_konto[0].options[o].text;
                        break;
                    }
                }
            }
        }

        $row.append($td.clone().html( (item.ec_modul ? item.ec_modul : '') + (item.contact_ext_group_id > 0 ? ': ' + item.contact_ext_group_name : '') ).attr('align', 'left') );
        $row.append($td.clone().html( item.oferta_nazwa ).attr('align', 'left') );
        $row.append($td.clone().html( item.oferta_od ).attr('align', 'left') );
        $row.append($td.clone().html( item.oferta_do ).attr('align', 'left') );

        if ( item.cena_id ) {
            $row.append($td.clone().html( item.cena_nazwa ).attr('align', 'left') );
        } else {
            $row.append($td.clone().html( '<b style="margin-right: 15px;">' + currency_format(item.cena_brutto) + ' ' + item.waluta_kod + '</b><br />'  + currency_format(item.cena_netto) + ' ' + item.waluta_kod ).attr('align', 'right') );
        }

        $row.append($td.attr('align', 'center').append( $a_edit  ).append($a_del) );

        return $row;
    }


    function ofertySpecjalneZapisz ( ) {
        var options;
        if ( arguments[0] ){
            options = arguments[0];
        }else if ( $element ) {
            options = $element.data('ecOfertySpecOptions');
        }

        if( !options ){
            return;
        }

        //usuwam wszystki inputy
        $(options.target).find('input').remove();

        for ( var i = 0; i < options.items.length ; i++  ){
            for( var a in options.items[i] ) {
                $(options.target).append('<input type="hidden" name="'+options.input+'[' + ( i ) + ']['+a+']" value="' + options.items[i][a] + '" />');
            }
        }
    }

    if ( $.fn.ecOfertySpec ) {
        return;
    }


    $.fn.ecOfertySpec = function( options ){
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        options = $.extend({
            items : [],
            name  : $(this).attr('id'),
            target : (!$(this).attr('href') || $(this).attr('href') == '#') ? $(this).attr('rel') : $(this).attr('href'),
            title : $(this).attr('title'),
            towar_nazwa: '',
            towar_id: null
        }, options || {} );

        if ( options.target && options.target.substr(0, 1) != '#' ){
            options.target = '#' + options.target;
        }

        if ( typeof(options.items) !== 'object' || options.items === null || typeof(options.items.length) === 'undefined' ) {
            options.items = [];
        }

        ofertySpecInit(options);

        this.button({
            'text' : '',
            'icons' : {
                'primary' : 'ui-icon-plus'
            }
        }).click (function ( e ){
            e.preventDefault();

            var href = $(this).attr('href');
            var href_match = href ? href.match(/#.*$/) : false;
            if ( href_match ) {
                href = href_match[0]
            }

            if ( href ) {
                //ustawiam aktualny element
                $element = $( href );

                if ( $element.length === 1 ) {
                    currentIndex = -1;
                    ofertaSpecDodaj();
                } else {
                    console.log('Nie znaleziono obiektu: ' + href );
                }
            } else {
                console.log('Nie znaleziono obiektu: ' + href );
            }

            return false;
        });
    }

})(jQuery);


