// JavaScript Document
var o_grid_table = null;
var grid_row = -1;

var o_grid_setups = new Object();

var grid_onenter = null;
var grid_ondelete =  null;
var grid_onescape =  null;
var grid_onspace = null;
var grid_onright = null; 
var grid_onleft  = null;
var grid_oninsert = null;

function grid_setup( grid_id, setup ){
    if( o_grid_table && o_grid_table.id == grid_id  ){
        o_grid_table = document.getElementById(grid_id);
        
        return true;
    }
    var o_table = document.getElementById(grid_id);

    if( !o_table ){
        alert('Nie znaleziono w dokumencie gridu: ' + grid_id);
        return false;
    }

    o_grid_setups[grid_id] = setup;
    
    o_table.onclick = function( e ){ grid_table_onclick(this, e); }

    if( !setup.no_grid ){
        o_table.parentNode.className = 'grid';
    }
    
    if( setup.init ){
        grid_row = 0;
        
        podswietl_wiersz( o_table.getElementsByTagName('TR').item(1) );
        
        o_table.onclick(null);
    }
    
}

function grid_table_onclick( o_table,  e ){

    if( !o_grid_table || o_table.id != o_grid_table.id ){
        
        o_grid_table = o_table;

        grid_set_functions( o_grid_setups[o_table.id] );

        add_event('onkeydown', document, grid_table_onkeydown, true );
        add_event('onclick', document, grid_doc_onclick, true );

        if( e ) grid_doc_onclick( e );
    }
}

function grid_set_functions( setup ){
    var f = null;
    
    for( f in setup ){
        if( typeof( setup[f] ) == 'function' ){
            window['grid_' + f] = setup[f];
        }
    }

}

function grid_doc_onclick( e ){
    e = (!e) ? window.event : e;

    // pobiera adresata zdarzenia
    var target = (!e.target) ? e.srcElement : e.target;
    var o_tr, o_td;
    if (target.nodeType == 3) target = target.parentNode;

    var o_obj = target;
    var znaleziono = false;
    while( o_obj && !znaleziono ){
        if( o_obj.id == o_grid_table.id ){
            znaleziono = true;
        }else if( o_obj.nodeName == 'TR' ){
            o_tr = o_obj;
        }

        o_obj = o_obj.parentNode;
    }

    if( znaleziono ){
        if( target.nodeName == 'INPUT' && target.type == 'checkbox' ){
            target.blur();
        }

        this.row = o_tr.rowIndex - 1;
    }else{
        remove_event( 'click', document );
        remove_event( 'keydown', document );

        grid_row  = -1;
        o_grid_table = null;
        podswietl_wiersz(null);
    }
}

function grid_table_onkeydown( e ){
    // pobiera zdarzenie
    e = (!e) ? window.event : e;

    // pobiera adresata zdarzenia
    var target = (!e.target) ? e.srcElement : e.target;

    if (target.nodeType == 3) target = target.parentNode;

    // pobiera kod znaku nacinitego klawisza
    var code = (e.charCode) ? e.charCode :((e.keyCode) ? e.keyCode :((e.which) ? e.which : 0));

    var old_num = 0;

    var stop_propagation = false;

    if( typeof(o_grid_setups[o_grid_table.id]['row']) == 'string' ){
        grid_row = window[o_grid_setups[o_grid_table.id]['row']];
    }

    var o_grid_table_rows     = o_grid_table.getElementsByTagName('TR');
    var rows_count = o_grid_table_rows.length - 1;
    var o_tr = o_grid_table_rows.item(grid_row + 1);
    
    switch( code ){
        case 13: // enter
            
            if( typeof(grid_onenter) == 'function' ){
                grid_onenter( grid_row, o_tr );

                grid_stop_propagation( e );
            }
            
            return false;
        break;

        case 46: // delete
            if( typeof(grid_ondelete) == 'function' ){
                grid_ondelete( grid_row, o_tr );
                
                grid_stop_propagation( e );
            }
            
            return false;
        break;
        
        case 27: // escape
            if( typeof(grid_onescape) == 'function' ){
                stop_propagation = true;
                
                grid_onescape( grid_row, o_tr );

                grid_stop_propagation( e );
                
                return false;
            }
        break;

        case 32: //spacja
          if( typeof(grid_onspace) == 'function' ){
              grid_stop_propagation( e );

              grid_onspace( grid_row, o_tr);
          }
          return false;
        break;
        
        case 45: //insert
          if( typeof(grid_oninsert) == 'function' ){
              grid_stop_propagation( e );

              grid_oninsert( grid_row, o_tr);
          }
          return false;
        break;


        //klawisz End
        case 35:
            stop_propagation = true;

            old_num  = grid_row;
            grid_row = rows_count - 1;
        break;

        //klawisz Home
        case 36:
            stop_propagation = true;

            old_num = grid_row;
            grid_row = 0;
        break;

        case 37: // left arrow
            if( typeof(grid_onleft) == 'function' ){

                grid_onleft( grid_row, o_tr );

                grid_stop_propagation( e );

                return false;
            }
        break;

        // nacinicie strzaki w g przenosi nas do poprzedniej podpowiedzi
        case 38:
          stop_propagation = true;
          
          if( grid_row > 0 ){
              old_num = grid_row--;
          }else if(grid_row == 0){
              old_num = grid_row;
              grid_row = rows_count - 1;
          }
        break;
        
        case 39: // right arrow
            if( typeof(grid_onright) == 'function' ){

                grid_onright( grid_row, o_tr );

                grid_stop_propagation( e );

                return false;
            }
        break;

        
        // po naciniciu strzaki w d przechodzi do kolejnej podpowiedzi
        case 40:
          stop_propagation = true;

          if( grid_row < rows_count - 1 ){
              old_num = grid_row++;
          }else{
              old_num = grid_row;
              grid_row = 0;
          }
        break;



    } //case

    o_tr = o_grid_table_rows.item(grid_row + 1);
    var o_grid_parent_div = o_grid_table.parentNode;

    if( o_tr ){
        podswietl_wiersz(o_tr);
        
        var y, y1  = 0;
        if( o_grid_parent_div.clientHeight < o_grid_table.scrollHeight ){
            y1 = o_tr.offsetTop;
            y = (o_tr.offsetTop + o_tr.scrollHeight);
            
            
        } else { //biore dokumen
            y1 = find_pos_y(o_tr)
            y = y1 + o_tr.scrollHeight ;
            
            o_grid_parent_div = document.body;
            
        }
        
        if( y > (o_grid_parent_div.scrollTop + o_grid_parent_div.clientHeight ) ){

            o_grid_parent_div.scrollTop = ((y - o_grid_parent_div.clientHeight) );

        }else if( y1 < o_grid_parent_div.scrollTop ){

            o_grid_parent_div.scrollTop = y1;
        }
    }

    if( typeof(o_grid_setups[o_grid_table.id]['row']) == 'string' ){
        window[o_grid_setups[o_grid_table.id]['row']] = grid_row;
    }

    if( stop_propagation ){
        grid_stop_propagation( e);
        return false;
    }

    return true;

}

function grid_stop_propagation( e ){

    e.cancelBubble = true;
    e.returnValue = false;

    try{
      e.stopPropagation();
      e.preventDefault();
    }catch(err){}

}

