// JavaScript Document
// JavaScript Document
/* --- GLOBAL VARS & DEFAULTS --- */
var preview_conf = new Array();

//parametr okreslajcy czy za polow ma si odby wywietlanie
preview_conf['halfFlip'] = true;

preview_conf['horizontalMargin'] = 5;
preview_conf['flippedHorizontalMargin'] = -4;
preview_conf['LoaderVerticalOffset'] = 0;
preview_conf['VerticalOffset'] = 42;
//predko odtwarzania
preview_conf['AnimationDelay'] = 0.8; //acceleration

preview_conf['PointerSrcLeft'] = SZABLON_URL + "/images/icons/img-arrow-left.gif";
preview_conf['PointerSrcRight'] = SZABLON_URL + "/images/icons/img-arrow-right.gif";
preview_conf['PointerWidth'] = 5;
preview_conf['PointerHeight'] = 9;
preview_conf['PointerHorizontalOffset'] = 1;
preview_conf['PointerVerticalOffset'] = 0;
preview_conf['url'] = '';

var preview_ajax = createXmlHttpRequestObject();

var preview;
var preview_contents;
var preview_arrow;
var preview_loader;

var previewBodyScrollTop;
var previewBrowserHeight;
var previewOrientation;
var previewFixedX;
var preview_timeout_id;
var previewBrowserBorderOffset;
var preview_el;
var preview_el_ref;

var preview_id;
var preview_delay_timeout_id;
var preview_flag            = true;
var previewIsImageLoaded    = false;

var preview_buffer          = new Object();

var preview_el_dim    = new Array();
var preview_dim       = new Array();
var preview_contents_dim  = new Array();


/*--- FUNCTIONS --- */

function preview_show_no_ajax( element, picture, title, desc ){
    if( preview_delay_timeout_id > 0 )
        clearTimeout(preview_delay_timeout_id);

    preview_buffer[0] = {
      'picture' : picture,
      'title' : title,
      'desc' : desc
    };

    preview_show( element, 0 );
}

function preview_show( element, id ){
    if( preview_delay_timeout_id )
      clearTimeout(preview_delay_timeout_id);

    preview_el = element;
    preview_id = id;

    // browser border offset
    if( navigator.appVersion.search("MSIE 6") != -1 || navigator.appVersion.search("MSIE 7") != -1 )
        previewBrowserBorderOffset = 0;
    else
        previewBrowserBorderOffset = 2;

    // flags and settings
    preview_flag = true;

    previewIsImageLoaded = false;

    // main elements
    if( !preview ){
        preview = document.getElementById('preview');
        if(!preview){
            preview_create();
        }else{
            preview_arrow = document.getElementById('preview_arrow');
            preview_loader = preview.getElementsByTagName('IMG').item(0);
            preview_contents = preview.getElementsByTagName('DIV').item(0);
        }
    }

    // set  default position
    preview.style.top  = '0px';
    preview.style.left = '0px';
    //zeby bya szerokosc i wysoko elementu
    preview.style.display = 'block';

    // body scroll
    previewBodyScrollTop = document.body.scrollTop;
    if ( previewBodyScrollTop == 0 ){
        if (window.pageYOffset)
            previewBodyScrollTop = window.pageYOffset;
        else if( window.scrollY )
            previewBodyScrollTop = window.scrollY;
        else
            previewBodyScrollTop = (document.body.parentElement) ? document.body.parentElement.scrollTop : 0;
    }

    // browser window height
    if( window.innerHeight )
        previewBrowserHeight = window.innerHeight;
    else
        previewBrowserHeight = document.body.clientHeight;


    get_dimensions( element, preview_el_dim );
    get_dimensions( preview, preview_dim );

    // convert base y dimension if no ajax
    //tego nie rozumiem
    //if( id == 0 ){
    //    preview_el_dim['y'] = preview_el_dim['y'] + 115;
    //}

    //alert(preview_el_dim['x'] + ", " + preview.offsetTop + ", " +preview_el_dim['width'] + ", " +preview_el_dim['height']);

    // calculate orientation,
    if(preview_conf['halfFlip'] == true){
        //jesli rodek lezy za polow to wyswietl element z prawj strony
        if ( (preview_el_dim['x'] + (preview_el_dim['width'] / 2) ) > (document.body.offsetWidth / 2) )
            previewOrientation = 0;
        else
            previewOrientation = 1;
    }else{
        if ( (preview_el_dim['x'] + preview_el_dim['width'] + preview.offsetWidth + preview_conf['horizontalMargin']) > document.body.offsetWidth )
            previewOrientation = 0;
        else
            previewOrientation = 1;
    }

    // calculate dimensions, position and show  loader

    // calculate x
    if(previewOrientation > 0 ){
        preview_dim['x'] = preview_el_dim['x'] + preview_el_dim['width'] + preview_conf['horizontalMargin'];
    }else{
        preview_dim['x'] = preview_el_dim['x'] - preview_dim['width'] - preview_conf['horizontalMargin'] + preview_conf['flippedHorizontalMargin'];
    }

    // calculate y
    if( preview_el_dim['y'] + preview_conf['LoaderVerticalOffset'] + preview_dim['height'] > previewBodyScrollTop + previewBrowserHeight)
        preview_dim['y'] = previewBodyScrollTop + previewBrowserHeight - preview_dim['height'];
    else
        preview_dim['y'] = preview_el_dim['y'] + preview_conf['LoaderVerticalOffset'];

    if( preview_dim['y'] < previewBodyScrollTop )
        preview_dim['y'] = previewBodyScrollTop;

    // move  pointer
    if( previewOrientation > 0){
        preview_arrow.src = preview_conf['PointerSrcLeft'];
        preview_arrow.style.left = (preview_dim['x'] - preview_conf['PointerWidth'] + preview_conf['PointerHorizontalOffset']) + "px";
    }else{
        preview_arrow.src = preview_conf['PointerSrcRight'];
        preview_arrow.style.left = (preview_dim['x'] + preview_dim['width'] - preview_conf['PointerHorizontalOffset']) + "px";
    }

    if( preview_el_dim['y'] +
            preview_conf['PointerHeight'] +
                preview_conf['PointerVerticalOffset'] > previewBodyScrollTop + previewBrowserHeight){

     preview_arrow.style.top = (previewBodyScrollTop + previewBrowserHeight - preview_conf['PointerHeight']) + "px";

    }else if ( preview_el_dim['y'] + preview_conf['PointerVerticalOffset'] < previewBodyScrollTop){
        preview_arrow.style.top = previewBodyScrollTop + "px";
    }else{
        preview_arrow.style.top = (preview_el_dim['y'] + (preview_el_dim['height'] / 2) - (preview_conf['PointerHeight'] / 2) + preview_conf['PointerVerticalOffset']) + "px";
    }

    // move
    preview.style.left = preview_dim['x'] + 'px';
    preview.style.top = preview_dim['y'] + 'px';

    // show  loader and pointer
    preview.style.visibility       = 'visible';
    preview_arrow.style.visibility = 'visible';
    preview_arrow.style.display = 'block';
    

    // get content (AJAX)
    preview_el_ref = element;
    preview_delay_timeout_id = setTimeout(function(){preview_get_content( id ); }, 400);

}

function preview_show_continue(){
    if( preview_flag == false ) {
        preview_hide();
    }

    get_dimensions( preview_contents, preview_contents_dim );

    //nie wiem po co to ale to chyba jakby cos poszo nie tak
    if ( preview_contents_dim['height'] < 52 ){
        preview_hide();
        preview_show( preview_el, preview_id);
        //setTimeout("preview_show( "+preview_el+", "+preview_id+" )", 100);
        return false;
    }

    // calculate  dimensions and offset

    // calculate x
    if( previewOrientation > 0 ){
        preview_contents_dim['x'] = preview_el_dim['x'] + preview_el_dim['width'] + preview_conf['horizontalMargin'];
    }else{
        preview_contents_dim['x'] = preview_el_dim['x'] - preview_contents_dim['width'] - preview_conf['horizontalMargin'] + preview_conf['flippedHorizontalMargin'];
    }

    // calculate y
    if( preview_el_dim['y'] + preview_conf['VerticalOffset'] > previewBodyScrollTop + previewBrowserHeight)
        preview_contents_dim['y'] = previewBodyScrollTop + previewBrowserHeight - preview_contents_dim['height'];
    else
        preview_contents_dim['y'] = preview_el_dim['y'] + preview_conf['VerticalOffset'] - preview_contents_dim['height'];

    if (preview_contents_dim['y'] < previewBodyScrollTop)
        preview_contents_dim['y'] = previewBodyScrollTop;

    // hide subcontainer and start animate
    //preview_contents.style.display = "none";

    preview_start_animate();

}

function preview_start_animate(){
    if( preview_flag == false ){
        preview_hide();
    }

    // calculate  fixed x
    if (previewOrientation > 0){
        previewFixedX = preview_contents_dim['x'];
    }else{
        previewFixedX = preview_contents_dim['x'] + preview_contents_dim['width'];
    }

    //ukrywam obrazek - loader
    preview_loader.style.visibility = "hidden";

    // animate
    preview_animation();
}

function preview_animation(){
    if( preview_flag == false ) {
        preview_hide();
    } // ---------------  ***

    var x, y, width, height;

    // height
    height = parseInt( preview_contents_dim['height'] -  Math.floor((preview_contents_dim['height'] - preview.offsetHeight) * preview_conf['AnimationDelay']));

    // width
    width = parseInt( preview_contents_dim['width'] -  Math.floor((preview_contents_dim['width'] - preview.offsetWidth) * preview_conf['AnimationDelay']) );

    // y
    y = parseInt(preview_contents_dim['y'] - Math.floor((preview_contents_dim['y'] - preview.offsetTop) * preview_conf['AnimationDelay'] ));

    // x
    if(previewOrientation > 0){
        x = previewFixedX;
    }else{
        x = previewFixedX - width - previewBrowserBorderOffset;
    }

    preview.style.left = x + "px";
    preview.style.top = y + "px";
    preview.style.width = width + "px";
    preview.style.height = height + "px";

    if( height < preview_contents_dim['height'] ){
        preview_timeout_id = setTimeout("preview_animation()", 30);

    }else{
        preview.style.left = (preview_contents_dim['x'] - ((previewOrientation > 0)?0:previewBrowserBorderOffset))+ "px";
        preview.style.top = preview_contents_dim['y'] + "px";
        preview.style.width = preview_contents_dim['width'] + "px";
        preview.style.height = preview_contents_dim['height'] + "px";

        //preview_contents.style.display  = "block";
        preview_contents.style.visibility = "visible";

        if(document.all){
            preview_contents.style.filter = "alpha(opacity=" + parseInt(0.1 * 100) + ")";
            preview_trans_inc_ie( 0.1, 0.1 );
        }else{
            preview_contents.style.opacity = 0.1;
            preview_trans_inc( 0.1, 0.1);
        }
    }
}

function preview_trans_inc_ie( last, step ){
    if(preview_flag == false) {
        preview_hide();
        return;
    } // ---------------  ***

    last += step;

    if( last >= 1 ){
        last = 1;
        preview_contents.style.filter = "alpha(opacity=" + parseInt(last * 100) + ")";
    }else{
        preview_contents.style.filter = "alpha(opacity=" + parseInt(last * 100) + ")";
        preview_timeout_id = setTimeout( function(){ preview_trans_inc_ie( last , step ); }, 60 );
    }
}


function preview_trans_inc( last, step ){
    if(preview_flag == false) {
        preview_hide();
        return;
    } // ---------------  ***

    last += step;

    if(last >= 1){
        preview_contents.style.opacity = last;
    }else{
        preview_contents.style.opacity = last;
        preview_timeout_id = setTimeout( function(){ preview_trans_inc(last , step); }, 60 );
    }

}

function preview_hide(){
    if(preview_delay_timeout_id) clearTimeout(preview_delay_timeout_id);
    clearTimeout(preview_timeout_id);


    preview_flag = false;
    preview.style.visibility = "hidden";
    preview.style.display = "none";
    preview.style.top = "0px";
    preview.style.left = "0px";
    
    

    // set  loader default dimensions
    if( preview_dim['width'] ){
        preview.style.width = (preview_dim['width'] - 2) + "px"; // border
        preview.style.height = (preview_dim['height'] - 2) + "px"; // border
    }


    preview_arrow.style.visibility = "hidden";
    preview_arrow.style.top = "0px";
    preview_arrow.style.left = "0px";

    preview_contents.style.visibility = "hidden";
    //preview_contents.style.overflow = "show";
    preview_contents.style.width = "0px";
    preview_contents.style.height = "0px";
    
    
    preview_loader.style.visibility = "visible";


    preview_dim['x'] = preview_dim['y'] = preview_dim['width'] = preview_dim['height'] = 0;
    //preview_dim['x'] = preview_dim['y'] = preview_dim['width'] = preview_dim['height'] = 0;
    preview_el_dim['x'] = preview_el_dim['y'] = preview_el_dim['width'] = preview_el_dim['height'] = 0;
}

//function preview_get_content( element, id ){
function preview_get_content( id ){
    element = preview_el_ref;

    if( preview_flag == false ) {
        preview_hide();
    }

    preview_contents.style.display = "block";
    preview_contents.style.width = 'auto';
    preview_contents.style.height = 'auto';
    
    var tempData = new Array();

    // AJAX or BUFFER
    if( preview_buffer[id] ){
        tempData = preview_buffer[0];
    }else{
        if( preview_conf['url'] ){
            //document.body.insertBefore(document.createTextNode(preview_conf['url'] + id), document.body.firstChild );
            setTimeout( function() { server_connect( preview_ajax, preview_conf['url'] + id, preview_handle_response );}, 50);
        }else{
            preview_hide();
        }
        return;
    }

    
    var html_str = '';
    if( tempData['title'] != '' ){
        html_str += '<h2>' + tempData['title'] + '</h2>';
    }

    if( tempData['desc'] != '' ){
        html_str += '<div>'+tempData['desc']+'</div>';
    }

    if( tempData['picture'] == "" ){
        preview_contents.innerHTML =  html_str ;
        preview_show_continue();
    }else{
        //alert(tempData['picture']);
        //document.body.insertBefore(document.createTextNode(tempData['picture']), document.body.firstChild );
        
        html_str += "<img src=\"" +tempData['picture']+ "\" onload=\"preview_show_continue()\" class=\"preview_image\" id=\"preview_img\">";
        preview_contents.innerHTML = html_str;
    }
}



function preview_handle_response( xmlRoot ){

    preview_buffer[0] = {
      'picture' : '',
      'title' : '',
      'desc' : 'Nie udao si pobra podgldu elementu'
    };

    var id = 0;

    var data_xml = xmlRoot.getElementsByTagName('data').item(0);

    if( data_xml != null ){
        preview_buffer[0]['desc'] = data_xml.firstChild.data;
    }

    preview_get_content( id );

}


function preview_create(){
    preview = document.createElement ('div');
		preview.id = 'preview';
    preview.className = 'preview';
    preview.style.position = 'absolute';
    preview.style.width  = 'auto';
    preview.style.height = 'auto';
    
    preview.onmouseover = function(){ preview_hide(); }
    
    preview_loader = document.createElement ('img');
    preview_loader.src = SZABLON_URL + '/images/loading.gif';
    preview_loader.id = 'preview_loader';
    preview_loader.className = 'preview_loader';
    preview_loader.border = 0;
    preview.appendChild (preview_loader);
    
    
    
    preview_contents = document.createElement('div');
		preview_contents.id = 'preview_contents';
    preview_contents.className = 'preview_contents';
    preview.appendChild (preview_contents);


    preview_arrow = document.createElement ('img');
    preview_arrow.src = preview_conf['PointerSrcLeft'];
    preview_arrow.id = 'preview_arrow';
    preview_arrow.className = 'preview_arrow';
    preview_arrow.border = 0;
    preview_arrow.style.position = 'absolute';

    document.body.insertBefore(preview_arrow, document.body.firstChild);
    document.body.insertBefore(preview, preview_arrow);
}
