
CREATE GENERATOR WWW_TOWARY_POWIADOMIENIA_ID_GEN;

CREATE TABLE WWW_TOWARY_POWIADOMIENIA (
    ID            SLOWNIK_D NOT NULL /* SLOWNIK_D = INTEGER */,
    TOWAR_ID      SLOWNIK_D NOT NULL /* SLOWNIK_D = INTEGER */,
    USER_ID       SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    EMAIL         ADRES_EMAIL_D NOT NULL /* ADRES_EMAIL_D = VARCHAR(64) */,
    TYP           INTEGER NOT NULL,
    CENA          CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    CDATE         DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */,
    NOTIFY_DATE   DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */,
    GUID          GUID_D NOT NULL /* GUID_D = CHAR(36) */,
    CONFIRM_DATE  DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */,
    INSTALACJA    WWW_INSTALACJA_D /* WWW_INSTALACJA_D = VARCHAR(30) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_TOWARY_POWIADOMIENIA ADD CONSTRAINT PK_WWW_TOWARY_POWIADOMIENIA PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE UNIQUE INDEX WWW_TOWARY_POWIADOMIENIA_GUID ON WWW_TOWARY_POWIADOMIENIA (GUID);
CREATE INDEX WWW_TOWARY_POWIA_EMAIL_IND ON WWW_TOWARY_POWIADOMIENIA (EMAIL);
CREATE INDEX WWW_TOWARY_POWIA_INSTALACJ_IND ON WWW_TOWARY_POWIADOMIENIA (INSTALACJA);
CREATE INDEX WWW_TOWARY_POWIA_TOWAR_ID_IND ON WWW_TOWARY_POWIADOMIENIA (TOWAR_ID);
CREATE INDEX WWW_TOWARY_POWIA_USER_ID_IND ON WWW_TOWARY_POWIADOMIENIA (USER_ID);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_TOWARY_POWIADOMIENIA_BI */
CREATE TRIGGER WWW_TOWARY_POWIADOMIENIA_BI FOR WWW_TOWARY_POWIADOMIENIA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_TOWARY_POWIADOMIENIA_ID_GEN,1);
END
^


SET TERM ; ^




/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_TOWARY_POWIADOMIENIA TO WWW_ROLE;