

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_TOWAR_OFERTY_ID_GEN;

CREATE TABLE WWW_TOWAR_OFERTY (
    ID           ID_D NOT NULL /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    TOWAR_ID     SLOWNIK_D NOT NULL /* SLOWNIK_D = INTEGER */,
    OFERTA_ID    SLOWNIK_D NOT NULL /* SLOWNIK_D = INTEGER */,
    EC_KONTO     SMALLINT,
    OFERTA_OD    DATA_D /* DATA_D = DATE */,
    OFERTA_DO    DATA_D /* DATA_D = DATE */,
    CENA_ID      SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    WALUTA_ID    SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    CENA_NETTO   WARTOSC_NULL_D /* WARTOSC_NULL_D = NUMERIC(18,4) */,
    CENA_BRUTTO  WARTOSC_NULL_D /* WARTOSC_NULL_D = NUMERIC(18,4) */,
    CDATE        DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */,
    MDATE        DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */,
    INSTALACJA   WWW_INSTALACJA_D /* WWW_INSTALACJA_D = VARCHAR(30) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_TOWAR_OFERTY ADD CONSTRAINT WWW_TOWAR_OFERTY_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_TOWAR_OFERTY_CENA_ID_IND ON WWW_TOWAR_OFERTY (CENA_ID);
CREATE INDEX WWW_TOWAR_OFERTY_DATY_IND ON WWW_TOWAR_OFERTY (CDATE, MDATE);
CREATE INDEX WWW_TOWAR_OFERTY_EC_KONTO_IND ON WWW_TOWAR_OFERTY (EC_KONTO);
CREATE INDEX WWW_TOWAR_OFERTY_OFERTA_DO_IND ON WWW_TOWAR_OFERTY (OFERTA_DO);
CREATE INDEX WWW_TOWAR_OFERTY_OFERTA_ID_IND ON WWW_TOWAR_OFERTY (OFERTA_ID);
CREATE INDEX WWW_TOWAR_OFERTY_OFERTA_OD_IND ON WWW_TOWAR_OFERTY (OFERTA_OD);
CREATE INDEX WWW_TOWAR_OFERTY_TOWAR_ID_IND ON WWW_TOWAR_OFERTY (TOWAR_ID);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_TOWAR_OFERTY_BI */
CREATE TRIGGER WWW_TOWAR_OFERTY_BI FOR WWW_TOWAR_OFERTY
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_TOWAR_OFERTY_ID_GEN,1);
END
^


SET TERM ; ^


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_TOWAR_OFERTY TO WWW_ROLE;